static const struct { const char *name; OptIndex opt_idx; } option_hash_elems[] = {
  { .name = "ma", .opt_idx = kOptModifiable },
  { .name = "wa", .opt_idx = kOptWriteany },
  { .name = "ea", .opt_idx = kOptEqualalways },
  { .name = "pa", .opt_idx = kOptPath },
  { .name = "eb", .opt_idx = kOptErrorbells },
  { .name = "wb", .opt_idx = kOptWritebackup },
  { .name = "vb", .opt_idx = kOptVisualbell },
  { .name = "sb", .opt_idx = kOptSplitbelow },
  { .name = "cb", .opt_idx = kOptClipboard },
  { .name = "pb", .opt_idx = kOptPumblend },
  { .name = "wc", .opt_idx = kOptWildchar },
  { .name = "cc", .opt_idx = kOptColorcolumn },
  { .name = "tc", .opt_idx = kOptTagcase },
  { .name = "uc", .opt_idx = kOptUpdatecount },
  { .name = "ic", .opt_idx = kOptIgnorecase },
  { .name = "sc", .opt_idx = kOptShowcmd },
  { .name = "wd", .opt_idx = kOptWritedelay },
  { .name = "gd", .opt_idx = kOptGdefault },
  { .name = "cd", .opt_idx = kOptCdpath },
  { .name = "sd", .opt_idx = kOptShada },
  { .name = "ed", .opt_idx = kOptEdcompatible },
  { .name = "ve", .opt_idx = kOptVirtualedit },
  { .name = "qe", .opt_idx = kOptQuoteescape },
  { .name = "re", .opt_idx = kOptRegexpengine },
  { .name = "cf", .opt_idx = kOptConfirm },
  { .name = "tf", .opt_idx = kOptTtyfast },
  { .name = "ef", .opt_idx = kOptErrorfile },
  { .name = "nf", .opt_idx = kOptNrformats },
  { .name = "hf", .opt_idx = kOptHelpfile },
  { .name = "ff", .opt_idx = kOptFileformat },
  { .name = "dg", .opt_idx = kOptDigraph },
  { .name = "bg", .opt_idx = kOptBackground },
  { .name = "ch", .opt_idx = kOptCmdheight },
  { .name = "wh", .opt_idx = kOptWinheight },
  { .name = "mh", .opt_idx = kOptMousehide },
  { .name = "bh", .opt_idx = kOptBufhidden },
  { .name = "hh", .opt_idx = kOptHelpheight },
  { .name = "sh", .opt_idx = kOptShell },
  { .name = "ph", .opt_idx = kOptPumheight },
  { .name = "wi", .opt_idx = kOptWindow },
  { .name = "ci", .opt_idx = kOptCopyindent },
  { .name = "ai", .opt_idx = kOptAutoindent },
  { .name = "hi", .opt_idx = kOptHistory },
  { .name = "ei", .opt_idx = kOptEventignore },
  { .name = "vi", .opt_idx = kOptShada },
  { .name = "ri", .opt_idx = kOptRevins },
  { .name = "si", .opt_idx = kOptSmartindent },
  { .name = "pi", .opt_idx = kOptPreserveindent },
  { .name = "sj", .opt_idx = kOptScrolljump },
  { .name = "bk", .opt_idx = kOptBackup },
  { .name = "hk", .opt_idx = kOptHkmap },
  { .name = "tl", .opt_idx = kOptTaglength },
  { .name = "al", .opt_idx = kOptAleph },
  { .name = "ul", .opt_idx = kOptUndolevels },
  { .name = "hl", .opt_idx = kOptHighlight },
  { .name = "ml", .opt_idx = kOptModeline },
  { .name = "bl", .opt_idx = kOptBuflisted },
  { .name = "rl", .opt_idx = kOptRightleft },
  { .name = "im", .opt_idx = kOptInsertmode },
  { .name = "wm", .opt_idx = kOptWrapmargin },
  { .name = "sm", .opt_idx = kOptShowmatch },
  { .name = "tm", .opt_idx = kOptTimeoutlen },
  { .name = "lm", .opt_idx = kOptLangmenu },
  { .name = "pm", .opt_idx = kOptPatchmode },
  { .name = "km", .opt_idx = kOptKeymodel },
  { .name = "co", .opt_idx = kOptColumns },
  { .name = "fo", .opt_idx = kOptFormatoptions },
  { .name = "bo", .opt_idx = kOptBelloff },
  { .name = "ro", .opt_idx = kOptReadonly },
  { .name = "so", .opt_idx = kOptScrolloff },
  { .name = "to", .opt_idx = kOptTimeout },
  { .name = "go", .opt_idx = kOptGuioptions },
  { .name = "cp", .opt_idx = kOptCompatible },
  { .name = "mp", .opt_idx = kOptMakeprg },
  { .name = "ep", .opt_idx = kOptEqualprg },
  { .name = "kp", .opt_idx = kOptKeywordprg },
  { .name = "gp", .opt_idx = kOptGrepprg },
  { .name = "sp", .opt_idx = kOptShellpipe },
  { .name = "fp", .opt_idx = kOptFormatprg },
  { .name = "pp", .opt_idx = kOptPackpath },
  { .name = "tr", .opt_idx = kOptTagrelative },
  { .name = "ar", .opt_idx = kOptAutoread },
  { .name = "ur", .opt_idx = kOptUndoreload },
  { .name = "sr", .opt_idx = kOptShiftround },
  { .name = "bs", .opt_idx = kOptBackspace },
  { .name = "is", .opt_idx = kOptIncsearch },
  { .name = "fs", .opt_idx = kOptFsync },
  { .name = "ls", .opt_idx = kOptLaststatus },
  { .name = "ws", .opt_idx = kOptWrapscan },
  { .name = "ss", .opt_idx = kOptSidescroll },
  { .name = "ts", .opt_idx = kOptTabstop },
  { .name = "js", .opt_idx = kOptJoinspaces },
  { .name = "ut", .opt_idx = kOptUpdatetime },
  { .name = "bt", .opt_idx = kOptBuftype },
  { .name = "ft", .opt_idx = kOptFiletype },
  { .name = "et", .opt_idx = kOptExpandtab },
  { .name = "pt", .opt_idx = kOptPastetoggle },
  { .name = "nu", .opt_idx = kOptNumber },
  { .name = "ru", .opt_idx = kOptRuler },
  { .name = "su", .opt_idx = kOptSuffixes },
  { .name = "lw", .opt_idx = kOptLispwords },
  { .name = "ww", .opt_idx = kOptWhichwrap },
  { .name = "aw", .opt_idx = kOptAutowrite },
  { .name = "pw", .opt_idx = kOptPumwidth },
  { .name = "sw", .opt_idx = kOptShiftwidth },
  { .name = "tw", .opt_idx = kOptTextwidth },
  { .name = "ex", .opt_idx = kOptExrc },
  { .name = "dy", .opt_idx = kOptDisplay },
  { .name = "lz", .opt_idx = kOptLazyredraw },
  { .name = "cia", .opt_idx = kOptCompleteitemalign },
  { .name = "sta", .opt_idx = kOptSmarttab },
  { .name = "sua", .opt_idx = kOptSuffixesadd },
  { .name = "awa", .opt_idx = kOptAutowriteall },
  { .name = "wfb", .opt_idx = kOptWinfixbuf },
  { .name = "swb", .opt_idx = kOptSwitchbuf },
  { .name = "crb", .opt_idx = kOptCursorbind },
  { .name = "rdb", .opt_idx = kOptRedrawdebug },
  { .name = "scb", .opt_idx = kOptScrollbind },
  { .name = "bkc", .opt_idx = kOptBackupcopy },
  { .name = "wic", .opt_idx = kOptWildignorecase },
  { .name = "cfc", .opt_idx = kOptCompletefuzzycollect },
  { .name = "tgc", .opt_idx = kOptTermguicolors },
  { .name = "cuc", .opt_idx = kOptCursorcolumn },
  { .name = "imc", .opt_idx = kOptImcmdline },
  { .name = "inc", .opt_idx = kOptInclude },
  { .name = "fdc", .opt_idx = kOptFoldcolumn },
  { .name = "rlc", .opt_idx = kOptRightleftcmd },
  { .name = "spc", .opt_idx = kOptSpellcapcheck },
  { .name = "smc", .opt_idx = kOptSynmaxcol },
  { .name = "stc", .opt_idx = kOptStatuscolumn },
  { .name = "fic", .opt_idx = kOptFileignorecase },
  { .name = "enc", .opt_idx = kOptEncoding },
  { .name = "acd", .opt_idx = kOptAutochdir },
  { .name = "mfd", .opt_idx = kOptMaxfuncdepth },
  { .name = "mmd", .opt_idx = kOptMaxmapdepth },
  { .name = "mod", .opt_idx = kOptModified },
  { .name = "imd", .opt_idx = kOptImdisable },
  { .name = "hid", .opt_idx = kOptHidden },
  { .name = "smd", .opt_idx = kOptShowmode },
  { .name = "ead", .opt_idx = kOptEadirection },
  { .name = "mle", .opt_idx = kOptModelineexpr },
  { .name = "fde", .opt_idx = kOptFoldexpr },
  { .name = "sxe", .opt_idx = kOptShellxescape },
  { .name = "mef", .opt_idx = kOptMakeef },
  { .name = "swf", .opt_idx = kOptSwapfile },
  { .name = "tpf", .opt_idx = kOptTermpastefilter },
  { .name = "def", .opt_idx = kOptDefine },
  { .name = "udf", .opt_idx = kOptUndofile },
  { .name = "inf", .opt_idx = kOptInfercase },
  { .name = "sdf", .opt_idx = kOptShadafile },
  { .name = "vif", .opt_idx = kOptShadafile },
  { .name = "ruf", .opt_idx = kOptRulerformat },
  { .name = "spf", .opt_idx = kOptSpellfile },
  { .name = "isf", .opt_idx = kOptIsfname },
  { .name = "eof", .opt_idx = kOptEndoffile },
  { .name = "wig", .opt_idx = kOptWildignore },
  { .name = "hlg", .opt_idx = kOptHelplang },
  { .name = "tag", .opt_idx = kOptTags },
  { .name = "cwh", .opt_idx = kOptCmdwinheight },
  { .name = "cdh", .opt_idx = kOptCdhome },
  { .name = "pvh", .opt_idx = kOptPreviewheight },
  { .name = "wmh", .opt_idx = kOptWinminheight },
  { .name = "wfh", .opt_idx = kOptWinfixheight },
  { .name = "ari", .opt_idx = kOptAllowrevins },
  { .name = "imi", .opt_idx = kOptIminsert },
  { .name = "fdi", .opt_idx = kOptFoldignore },
  { .name = "bri", .opt_idx = kOptBreakindent },
  { .name = "lhi", .opt_idx = kOptLhistory },
  { .name = "chi", .opt_idx = kOptChistory },
  { .name = "isi", .opt_idx = kOptIsident },
  { .name = "wak", .opt_idx = kOptWinaltkeys },
  { .name = "bsk", .opt_idx = kOptBackupskip },
  { .name = "isk", .opt_idx = kOptIskeyword },
  { .name = "brk", .opt_idx = kOptBreakat },
  { .name = "spk", .opt_idx = kOptSplitkeep },
  { .name = "eol", .opt_idx = kOptEndofline },
  { .name = "lpl", .opt_idx = kOptLoadplugins },
  { .name = "tcl", .opt_idx = kOptTabclose },
  { .name = "tal", .opt_idx = kOptTabline },
  { .name = "csl", .opt_idx = kOptCompleteslash },
  { .name = "cul", .opt_idx = kOptCursorline },
  { .name = "fcl", .opt_idx = kOptFoldclose },
  { .name = "fdl", .opt_idx = kOptFoldlevel },
  { .name = "fml", .opt_idx = kOptFoldminlines },
  { .name = "gtl", .opt_idx = kOptGuitablabel },
  { .name = "ssl", .opt_idx = kOptShellslash },
  { .name = "scl", .opt_idx = kOptSigncolumn },
  { .name = "sel", .opt_idx = kOptSelection },
  { .name = "spl", .opt_idx = kOptSpelllang },
  { .name = "sol", .opt_idx = kOptStartofline },
  { .name = "stl", .opt_idx = kOptStatusline },
  { .name = "wcm", .opt_idx = kOptWildcharm },
  { .name = "wim", .opt_idx = kOptWildmode },
  { .name = "com", .opt_idx = kOptComments },
  { .name = "tpm", .opt_idx = kOptTabpagemax },
  { .name = "ttm", .opt_idx = kOptTtimeoutlen },
  { .name = "msm", .opt_idx = kOptMkspellmem },
  { .name = "icm", .opt_idx = kOptInccommand },
  { .name = "fdm", .opt_idx = kOptFoldmethod },
  { .name = "shm", .opt_idx = kOptShortmess },
  { .name = "lrm", .opt_idx = kOptLangremap },
  { .name = "gfm", .opt_idx = kOptGrepformat },
  { .name = "efm", .opt_idx = kOptErrorformat },
  { .name = "slm", .opt_idx = kOptSelectmode },
  { .name = "syn", .opt_idx = kOptSyntax },
  { .name = "bin", .opt_idx = kOptBinary },
  { .name = "fdn", .opt_idx = kOptFoldnestmax },
  { .name = "gfn", .opt_idx = kOptGuifont },
  { .name = "fen", .opt_idx = kOptFoldenable },
  { .name = "cin", .opt_idx = kOptCindent },
  { .name = "cpo", .opt_idx = kOptCpoptions },
  { .name = "mco", .opt_idx = kOptMaxcombine },
  { .name = "fdo", .opt_idx = kOptFoldopen },
  { .name = "sbo", .opt_idx = kOptScrollopt },
  { .name = "spo", .opt_idx = kOptSpelloptions },
  { .name = "emo", .opt_idx = kOptEmoji },
  { .name = "wop", .opt_idx = kOptWildoptions },
  { .name = "dip", .opt_idx = kOptDiffopt },
  { .name = "mmp", .opt_idx = kOptMaxmempattern },
  { .name = "hkp", .opt_idx = kOptHkmapp },
  { .name = "jop", .opt_idx = kOptJumpoptions },
  { .name = "kmp", .opt_idx = kOptKeymap },
  { .name = "flp", .opt_idx = kOptFormatlistpat },
  { .name = "cmp", .opt_idx = kOptCasemap },
  { .name = "lsp", .opt_idx = kOptLinespace },
  { .name = "lop", .opt_idx = kOptLispoptions },
  { .name = "rtp", .opt_idx = kOptRuntimepath },
  { .name = "vop", .opt_idx = kOptViewoptions },
  { .name = "top", .opt_idx = kOptTildeop },
  { .name = "isp", .opt_idx = kOptIsprint },
  { .name = "sxq", .opt_idx = kOptShellxquote },
  { .name = "shq", .opt_idx = kOptShellquote },
  { .name = "wbr", .opt_idx = kOptWinbar },
  { .name = "fmr", .opt_idx = kOptFoldmarker },
  { .name = "sbr", .opt_idx = kOptShowbreak },
  { .name = "gcr", .opt_idx = kOptGuicursor },
  { .name = "lbr", .opt_idx = kOptLinebreak },
  { .name = "dir", .opt_idx = kOptDirectory },
  { .name = "srr", .opt_idx = kOptShellredir },
  { .name = "scr", .opt_idx = kOptScroll },
  { .name = "tsr", .opt_idx = kOptThesaurus },
  { .name = "spr", .opt_idx = kOptSplitright },
  { .name = "lnr", .opt_idx = kOptLangnoremap },
  { .name = "lcs", .opt_idx = kOptListchars },
  { .name = "cms", .opt_idx = kOptCommentstring },
  { .name = "tbs", .opt_idx = kOptTagbsearch },
  { .name = "mps", .opt_idx = kOptMatchpairs },
  { .name = "vts", .opt_idx = kOptVartabstop },
  { .name = "mis", .opt_idx = kOptMenuitems },
  { .name = "mls", .opt_idx = kOptModelines },
  { .name = "ims", .opt_idx = kOptImsearch },
  { .name = "fcs", .opt_idx = kOptFillchars },
  { .name = "vbs", .opt_idx = kOptVerbose },
  { .name = "sms", .opt_idx = kOptSmoothscroll },
  { .name = "sps", .opt_idx = kOptSpellsuggest },
  { .name = "sts", .opt_idx = kOptSofttabstop },
  { .name = "scs", .opt_idx = kOptSmartcase },
  { .name = "hls", .opt_idx = kOptHlsearch },
  { .name = "ffs", .opt_idx = kOptFileformats },
  { .name = "cpt", .opt_idx = kOptComplete },
  { .name = "cot", .opt_idx = kOptCompleteopt },
  { .name = "mat", .opt_idx = kOptMatchtime },
  { .name = "fdt", .opt_idx = kOptFoldtext },
  { .name = "gtt", .opt_idx = kOptGuitabtooltip },
  { .name = "rdt", .opt_idx = kOptRedrawtime },
  { .name = "sft", .opt_idx = kOptShowfulltag },
  { .name = "cfu", .opt_idx = kOptCompletefunc },
  { .name = "tfu", .opt_idx = kOptTagfunc },
  { .name = "ffu", .opt_idx = kOptFindfunc },
  { .name = "ofu", .opt_idx = kOptOmnifunc },
  { .name = "rnu", .opt_idx = kOptRelativenumber },
  { .name = "ccv", .opt_idx = kOptCharconvert },
  { .name = "wfw", .opt_idx = kOptWinfixwidth },
  { .name = "wiw", .opt_idx = kOptWinwidth },
  { .name = "eiw", .opt_idx = kOptEventignorewin },
  { .name = "gfw", .opt_idx = kOptGuifontwide },
  { .name = "pvw", .opt_idx = kOptPreviewwindow },
  { .name = "wmw", .opt_idx = kOptWinminwidth },
  { .name = "nuw", .opt_idx = kOptNumberwidth },
  { .name = "pmw", .opt_idx = kOptPummaxwidth },
  { .name = "dex", .opt_idx = kOptDiffexpr },
  { .name = "pyx", .opt_idx = kOptPyxversion },
  { .name = "bex", .opt_idx = kOptBackupext },
  { .name = "fex", .opt_idx = kOptFormatexpr },
  { .name = "pex", .opt_idx = kOptPatchexpr },
  { .name = "para", .opt_idx = kOptParagraphs },
  { .name = "bomb", .opt_idx = kOptBomb },
  { .name = "arab", .opt_idx = kOptArabic },
  { .name = "fenc", .opt_idx = kOptFileencoding },
  { .name = "exrc", .opt_idx = kOptExrc },
  { .name = "sloc", .opt_idx = kOptShowcmdloc },
  { .name = "tenc", .opt_idx = kOptTermencoding },
  { .name = "menc", .opt_idx = kOptMakeencoding },
  { .name = "cole", .opt_idx = kOptConceallevel },
  { .name = "more", .opt_idx = kOptMore },
  { .name = "inde", .opt_idx = kOptIndentexpr },
  { .name = "diff", .opt_idx = kOptDiff },
  { .name = "shcf", .opt_idx = kOptShellcmdflag },
  { .name = "qftf", .opt_idx = kOptQuickfixtextfunc },
  { .name = "path", .opt_idx = kOptPath },
  { .name = "cink", .opt_idx = kOptCinkeys },
  { .name = "scbk", .opt_idx = kOptScrollback },
  { .name = "indk", .opt_idx = kOptIndentkeys },
  { .name = "stal", .opt_idx = kOptShowtabline },
  { .name = "warn", .opt_idx = kOptWarn },
  { .name = "icon", .opt_idx = kOptIcon },
  { .name = "deco", .opt_idx = kOptDelcombine },
  { .name = "siso", .opt_idx = kOptSidescrolloff },
  { .name = "cino", .opt_idx = kOptCinoptions },
  { .name = "lisp", .opt_idx = kOptLisp },
  { .name = "stmp", .opt_idx = kOptShelltemp },
  { .name = "ssop", .opt_idx = kOptSessionoptions },
  { .name = "wrap", .opt_idx = kOptWrap },
  { .name = "lmap", .opt_idx = kOptLangmap },
  { .name = "bdir", .opt_idx = kOptBackupdir },
  { .name = "udir", .opt_idx = kOptUndodir },
  { .name = "vdir", .opt_idx = kOptViewdir },
  { .name = "vsts", .opt_idx = kOptVarsofttabstop },
  { .name = "tags", .opt_idx = kOptTags },
  { .name = "fdls", .opt_idx = kOptFoldlevelstart },
  { .name = "tgst", .opt_idx = kOptTagstack },
  { .name = "dict", .opt_idx = kOptDictionary },
  { .name = "mopt", .opt_idx = kOptMessagesopt },
  { .name = "sect", .opt_idx = kOptSections },
  { .name = "list", .opt_idx = kOptList },
  { .name = "wmnu", .opt_idx = kOptWildmenu },
  { .name = "cocu", .opt_idx = kOptConcealcursor },
  { .name = "odev", .opt_idx = kOptOpendevice },
  { .name = "cinw", .opt_idx = kOptCinwords },
  { .name = "ambw", .opt_idx = kOptAmbiwidth },
  { .name = "inex", .opt_idx = kOptIncludeexpr },
  { .name = "aleph", .opt_idx = kOptAleph },
  { .name = "bsdir", .opt_idx = kOptBrowsedir },
  { .name = "cinsd", .opt_idx = kOptCinscopedecls },
  { .name = "cedit", .opt_idx = kOptCedit },
  { .name = "debug", .opt_idx = kOptDebug },
  { .name = "emoji", .opt_idx = kOptEmoji },
  { .name = "fencs", .opt_idx = kOptFileencodings },
  { .name = "fsync", .opt_idx = kOptFsync },
  { .name = "hkmap", .opt_idx = kOptHkmap },
  { .name = "lines", .opt_idx = kOptLines },
  { .name = "magic", .opt_idx = kOptMagic },
  { .name = "mouse", .opt_idx = kOptMouse },
  { .name = "paste", .opt_idx = kOptPaste },
  { .name = "remap", .opt_idx = kOptRemap },
  { .name = "ruler", .opt_idx = kOptRuler },
  { .name = "shell", .opt_idx = kOptShell },
  { .name = "shada", .opt_idx = kOptShada },
  { .name = "spell", .opt_idx = kOptSpell },
  { .name = "tbidi", .opt_idx = kOptTermbidi },
  { .name = "terse", .opt_idx = kOptTerse },
  { .name = "tsrfu", .opt_idx = kOptThesaurusfunc },
  { .name = "title", .opt_idx = kOptTitle },
  { .name = "vfile", .opt_idx = kOptVerbosefile },
  { .name = "winbl", .opt_idx = kOptWinblend },
  { .name = "winhl", .opt_idx = kOptWinhighlight },
  { .name = "write", .opt_idx = kOptWrite },
  { .name = "arabic", .opt_idx = kOptArabic },
  { .name = "backup", .opt_idx = kOptBackup },
  { .name = "secure", .opt_idx = kOptSecure },
  { .name = "hidden", .opt_idx = kOptHidden },
  { .name = "define", .opt_idx = kOptDefine },
  { .name = "opfunc", .opt_idx = kOptOperatorfunc },
  { .name = "cdhome", .opt_idx = kOptCdhome },
  { .name = "briopt", .opt_idx = kOptBreakindentopt },
  { .name = "makeef", .opt_idx = kOptMakeef },
  { .name = "culopt", .opt_idx = kOptCursorlineopt },
  { .name = "number", .opt_idx = kOptNumber },
  { .name = "hkmapp", .opt_idx = kOptHkmapp },
  { .name = "binary", .opt_idx = kOptBinary },
  { .name = "window", .opt_idx = kOptWindow },
  { .name = "winbar", .opt_idx = kOptWinbar },
  { .name = "syntax", .opt_idx = kOptSyntax },
  { .name = "prompt", .opt_idx = kOptPrompt },
  { .name = "report", .opt_idx = kOptReport },
  { .name = "cdpath", .opt_idx = kOptCdpath },
  { .name = "scroll", .opt_idx = kOptScroll },
  { .name = "mousef", .opt_idx = kOptMousefocus },
  { .name = "mousem", .opt_idx = kOptMousemodel },
  { .name = "mouses", .opt_idx = kOptMouseshape },
  { .name = "mouset", .opt_idx = kOptMousetime },
  { .name = "revins", .opt_idx = kOptRevins },
  { .name = "fixeol", .opt_idx = kOptFixendofline },
  { .name = "keymap", .opt_idx = kOptKeymap },
  { .name = "channel", .opt_idx = kOptChannel },
  { .name = "tabstop", .opt_idx = kOptTabstop },
  { .name = "tabline", .opt_idx = kOptTabline },
  { .name = "include", .opt_idx = kOptInclude },
  { .name = "undodir", .opt_idx = kOptUndodir },
  { .name = "viewdir", .opt_idx = kOptViewdir },
  { .name = "breakat", .opt_idx = kOptBreakat },
  { .name = "grepprg", .opt_idx = kOptGrepprg },
  { .name = "isfname", .opt_idx = kOptIsfname },
  { .name = "buftype", .opt_idx = kOptBuftype },
  { .name = "diffopt", .opt_idx = kOptDiffopt },
  { .name = "tagcase", .opt_idx = kOptTagcase },
  { .name = "tagfunc", .opt_idx = kOptTagfunc },
  { .name = "digraph", .opt_idx = kOptDigraph },
  { .name = "isident", .opt_idx = kOptIsident },
  { .name = "guifont", .opt_idx = kOptGuifont },
  { .name = "makeprg", .opt_idx = kOptMakeprg },
  { .name = "columns", .opt_idx = kOptColumns },
  { .name = "belloff", .opt_idx = kOptBelloff },
  { .name = "tildeop", .opt_idx = kOptTildeop },
  { .name = "timeout", .opt_idx = kOptTimeout },
  { .name = "viminfo", .opt_idx = kOptShada },
  { .name = "confirm", .opt_idx = kOptConfirm },
  { .name = "cindent", .opt_idx = kOptCindent },
  { .name = "cinkeys", .opt_idx = kOptCinkeys },
  { .name = "langmap", .opt_idx = kOptLangmap },
  { .name = "showcmd", .opt_idx = kOptShowcmd },
  { .name = "isprint", .opt_idx = kOptIsprint },
  { .name = "verbose", .opt_idx = kOptVerbose },
  { .name = "history", .opt_idx = kOptHistory },
  { .name = "casemap", .opt_idx = kOptCasemap },
  { .name = "display", .opt_idx = kOptDisplay },
  { .name = "arshape", .opt_idx = kOptArabicshape },
  { .name = "ttyfast", .opt_idx = kOptTtyfast },
  { .name = "autoread", .opt_idx = kOptAutoread },
  { .name = "cinwords", .opt_idx = kOptCinwords },
  { .name = "comments", .opt_idx = kOptComments },
  { .name = "complete", .opt_idx = kOptComplete },
  { .name = "chistory", .opt_idx = kOptChistory },
  { .name = "diffexpr", .opt_idx = kOptDiffexpr },
  { .name = "equalprg", .opt_idx = kOptEqualprg },
  { .name = "encoding", .opt_idx = kOptEncoding },
  { .name = "findfunc", .opt_idx = kOptFindfunc },
  { .name = "foldexpr", .opt_idx = kOptFoldexpr },
  { .name = "foldopen", .opt_idx = kOptFoldopen },
  { .name = "foldtext", .opt_idx = kOptFoldtext },
  { .name = "filetype", .opt_idx = kOptFiletype },
  { .name = "gdefault", .opt_idx = kOptGdefault },
  { .name = "helpfile", .opt_idx = kOptHelpfile },
  { .name = "helplang", .opt_idx = kOptHelplang },
  { .name = "hlsearch", .opt_idx = kOptHlsearch },
  { .name = "iminsert", .opt_idx = kOptIminsert },
  { .name = "imsearch", .opt_idx = kOptImsearch },
  { .name = "keymodel", .opt_idx = kOptKeymodel },
  { .name = "lhistory", .opt_idx = kOptLhistory },
  { .name = "langmenu", .opt_idx = kOptLangmenu },
  { .name = "modeline", .opt_idx = kOptModeline },
  { .name = "modified", .opt_idx = kOptModified },
  { .name = "mousemev", .opt_idx = kOptMousemoveevent },
  { .name = "omnifunc", .opt_idx = kOptOmnifunc },
  { .name = "packpath", .opt_idx = kOptPackpath },
  { .name = "pumwidth", .opt_idx = kOptPumwidth },
  { .name = "pumblend", .opt_idx = kOptPumblend },
  { .name = "readonly", .opt_idx = kOptReadonly },
  { .name = "swapfile", .opt_idx = kOptSwapfile },
  { .name = "sections", .opt_idx = kOptSections },
  { .name = "smarttab", .opt_idx = kOptSmarttab },
  { .name = "showmode", .opt_idx = kOptShowmode },
  { .name = "suffixes", .opt_idx = kOptSuffixes },
  { .name = "tabclose", .opt_idx = kOptTabclose },
  { .name = "termbidi", .opt_idx = kOptTermbidi },
  { .name = "titlelen", .opt_idx = kOptTitlelen },
  { .name = "ttimeout", .opt_idx = kOptTtimeout },
  { .name = "titleold", .opt_idx = kOptTitleold },
  { .name = "termsync", .opt_idx = kOptTermsync },
  { .name = "tagstack", .opt_idx = kOptTagstack },
  { .name = "undofile", .opt_idx = kOptUndofile },
  { .name = "wildchar", .opt_idx = kOptWildchar },
  { .name = "wildmenu", .opt_idx = kOptWildmenu },
  { .name = "winblend", .opt_idx = kOptWinblend },
  { .name = "winwidth", .opt_idx = kOptWinwidth },
  { .name = "wrapscan", .opt_idx = kOptWrapscan },
  { .name = "writeany", .opt_idx = kOptWriteany },
  { .name = "wildmode", .opt_idx = kOptWildmode },
  { .name = "whichwrap", .opt_idx = kOptWhichwrap },
  { .name = "expandtab", .opt_idx = kOptExpandtab },
  { .name = "langremap", .opt_idx = kOptLangremap },
  { .name = "showbreak", .opt_idx = kOptShowbreak },
  { .name = "linebreak", .opt_idx = kOptLinebreak },
  { .name = "backspace", .opt_idx = kOptBackspace },
  { .name = "linespace", .opt_idx = kOptLinespace },
  { .name = "showmatch", .opt_idx = kOptShowmatch },
  { .name = "incsearch", .opt_idx = kOptIncsearch },
  { .name = "lispwords", .opt_idx = kOptLispwords },
  { .name = "mousehide", .opt_idx = kOptMousehide },
  { .name = "patchmode", .opt_idx = kOptPatchmode },
  { .name = "winborder", .opt_idx = kOptWinborder },
  { .name = "modelines", .opt_idx = kOptModelines },
  { .name = "foldlevel", .opt_idx = kOptFoldlevel },
  { .name = "bufhidden", .opt_idx = kOptBufhidden },
  { .name = "splitkeep", .opt_idx = kOptSplitkeep },
  { .name = "buflisted", .opt_idx = kOptBuflisted },
  { .name = "rightleft", .opt_idx = kOptRightleft },
  { .name = "scrolloff", .opt_idx = kOptScrolloff },
  { .name = "cmdheight", .opt_idx = kOptCmdheight },
  { .name = "highlight", .opt_idx = kOptHighlight },
  { .name = "pumheight", .opt_idx = kOptPumheight },
  { .name = "winheight", .opt_idx = kOptWinheight },
  { .name = "backupdir", .opt_idx = kOptBackupdir },
  { .name = "autochdir", .opt_idx = kOptAutochdir },
  { .name = "browsedir", .opt_idx = kOptBrowsedir },
  { .name = "endoffile", .opt_idx = kOptEndoffile },
  { .name = "shadafile", .opt_idx = kOptShadafile },
  { .name = "spellfile", .opt_idx = kOptSpellfile },
  { .name = "imdisable", .opt_idx = kOptImdisable },
  { .name = "errorfile", .opt_idx = kOptErrorfile },
  { .name = "matchtime", .opt_idx = kOptMatchtime },
  { .name = "menuitems", .opt_idx = kOptMenuitems },
  { .name = "mousetime", .opt_idx = kOptMousetime },
  { .name = "shelltemp", .opt_idx = kOptShelltemp },
  { .name = "cpoptions", .opt_idx = kOptCpoptions },
  { .name = "spelllang", .opt_idx = kOptSpelllang },
  { .name = "imcmdline", .opt_idx = kOptImcmdline },
  { .name = "endofline", .opt_idx = kOptEndofline },
  { .name = "synmaxcol", .opt_idx = kOptSynmaxcol },
  { .name = "guicursor", .opt_idx = kOptGuicursor },
  { .name = "selection", .opt_idx = kOptSelection },
  { .name = "shellpipe", .opt_idx = kOptShellpipe },
  { .name = "scrollopt", .opt_idx = kOptScrollopt },
  { .name = "patchexpr", .opt_idx = kOptPatchexpr },
  { .name = "listchars", .opt_idx = kOptListchars },
  { .name = "wildcharm", .opt_idx = kOptWildcharm },
  { .name = "clipboard", .opt_idx = kOptClipboard },
  { .name = "formatprg", .opt_idx = kOptFormatprg },
  { .name = "directory", .opt_idx = kOptDirectory },
  { .name = "fillchars", .opt_idx = kOptFillchars },
  { .name = "iskeyword", .opt_idx = kOptIskeyword },
  { .name = "infercase", .opt_idx = kOptInfercase },
  { .name = "shortmess", .opt_idx = kOptShortmess },
  { .name = "smartcase", .opt_idx = kOptSmartcase },
  { .name = "foldclose", .opt_idx = kOptFoldclose },
  { .name = "taglength", .opt_idx = kOptTaglength },
  { .name = "textwidth", .opt_idx = kOptTextwidth },
  { .name = "autowrite", .opt_idx = kOptAutowrite },
  { .name = "nrformats", .opt_idx = kOptNrformats },
  { .name = "ambiwidth", .opt_idx = kOptAmbiwidth },
  { .name = "switchbuf", .opt_idx = kOptSwitchbuf },
  { .name = "winfixbuf", .opt_idx = kOptWinfixbuf },
  { .name = "thesaurus", .opt_idx = kOptThesaurus },
  { .name = "backupext", .opt_idx = kOptBackupext },
  { .name = "tagbsearch", .opt_idx = kOptTagbsearch },
  { .name = "matchpairs", .opt_idx = kOptMatchpairs },
  { .name = "modifiable", .opt_idx = kOptModifiable },
  { .name = "joinspaces", .opt_idx = kOptJoinspaces },
  { .name = "paragraphs", .opt_idx = kOptParagraphs },
  { .name = "foldenable", .opt_idx = kOptFoldenable },
  { .name = "laststatus", .opt_idx = kOptLaststatus },
  { .name = "visualbell", .opt_idx = kOptVisualbell },
  { .name = "cursorbind", .opt_idx = kOptCursorbind },
  { .name = "delcombine", .opt_idx = kOptDelcombine },
  { .name = "maxcombine", .opt_idx = kOptMaxcombine },
  { .name = "scrollback", .opt_idx = kOptScrollback },
  { .name = "scrollbind", .opt_idx = kOptScrollbind },
  { .name = "backupcopy", .opt_idx = kOptBackupcopy },
  { .name = "ignorecase", .opt_idx = kOptIgnorecase },
  { .name = "copyindent", .opt_idx = kOptCopyindent },
  { .name = "autoindent", .opt_idx = kOptAutoindent },
  { .name = "lazyredraw", .opt_idx = kOptLazyredraw },
  { .name = "showcmdloc", .opt_idx = kOptShowcmdloc },
  { .name = "keywordprg", .opt_idx = kOptKeywordprg },
  { .name = "errorbells", .opt_idx = kOptErrorbells },
  { .name = "writedelay", .opt_idx = kOptWritedelay },
  { .name = "formatexpr", .opt_idx = kOptFormatexpr },
  { .name = "shellredir", .opt_idx = kOptShellredir },
  { .name = "tabpagemax", .opt_idx = kOptTabpagemax },
  { .name = "splitbelow", .opt_idx = kOptSplitbelow },
  { .name = "indentexpr", .opt_idx = kOptIndentexpr },
  { .name = "mouseshape", .opt_idx = kOptMouseshape },
  { .name = "cinoptions", .opt_idx = kOptCinoptions },
  { .name = "compatible", .opt_idx = kOptCompatible },
  { .name = "guioptions", .opt_idx = kOptGuioptions },
  { .name = "helpheight", .opt_idx = kOptHelpheight },
  { .name = "shiftwidth", .opt_idx = kOptShiftwidth },
  { .name = "splitright", .opt_idx = kOptSplitright },
  { .name = "scrolljump", .opt_idx = kOptScrolljump },
  { .name = "indentkeys", .opt_idx = kOptIndentkeys },
  { .name = "winaltkeys", .opt_idx = kOptWinaltkeys },
  { .name = "cursorline", .opt_idx = kOptCursorline },
  { .name = "undoreload", .opt_idx = kOptUndoreload },
  { .name = "mkspellmem", .opt_idx = kOptMkspellmem },
  { .name = "foldcolumn", .opt_idx = kOptFoldcolumn },
  { .name = "shellslash", .opt_idx = kOptShellslash },
  { .name = "signcolumn", .opt_idx = kOptSigncolumn },
  { .name = "statusline", .opt_idx = kOptStatusline },
  { .name = "inccommand", .opt_idx = kOptInccommand },
  { .name = "insertmode", .opt_idx = kOptInsertmode },
  { .name = "selectmode", .opt_idx = kOptSelectmode },
  { .name = "wildignore", .opt_idx = kOptWildignore },
  { .name = "dictionary", .opt_idx = kOptDictionary },
  { .name = "foldignore", .opt_idx = kOptFoldignore },
  { .name = "background", .opt_idx = kOptBackground },
  { .name = "mousefocus", .opt_idx = kOptMousefocus },
  { .name = "mousemodel", .opt_idx = kOptMousemodel },
  { .name = "shiftround", .opt_idx = kOptShiftround },
  { .name = "fileformat", .opt_idx = kOptFileformat },
  { .name = "wrapmargin", .opt_idx = kOptWrapmargin },
  { .name = "sidescroll", .opt_idx = kOptSidescroll },
  { .name = "grepformat", .opt_idx = kOptGrepformat },
  { .name = "foldmarker", .opt_idx = kOptFoldmarker },
  { .name = "iconstring", .opt_idx = kOptIconstring },
  { .name = "backupskip", .opt_idx = kOptBackupskip },
  { .name = "pyxversion", .opt_idx = kOptPyxversion },
  { .name = "vartabstop", .opt_idx = kOptVartabstop },
  { .name = "timeoutlen", .opt_idx = kOptTimeoutlen },
  { .name = "updatetime", .opt_idx = kOptUpdatetime },
  { .name = "foldmethod", .opt_idx = kOptFoldmethod },
  { .name = "redrawtime", .opt_idx = kOptRedrawtime },
  { .name = "shellquote", .opt_idx = kOptShellquote },
  { .name = "undolevels", .opt_idx = kOptUndolevels },
  { .name = "opendevice", .opt_idx = kOptOpendevice },
  { .name = "virtualedit", .opt_idx = kOptVirtualedit },
  { .name = "equalalways", .opt_idx = kOptEqualalways },
  { .name = "softtabstop", .opt_idx = kOptSofttabstop },
  { .name = "showtabline", .opt_idx = kOptShowtabline },
  { .name = "guitablabel", .opt_idx = kOptGuitablabel },
  { .name = "writebackup", .opt_idx = kOptWritebackup },
  { .name = "colorcolumn", .opt_idx = kOptColorcolumn },
  { .name = "arabicshape", .opt_idx = kOptArabicshape },
  { .name = "includeexpr", .opt_idx = kOptIncludeexpr },
  { .name = "completeopt", .opt_idx = kOptCompleteopt },
  { .name = "updatecount", .opt_idx = kOptUpdatecount },
  { .name = "foldnestmax", .opt_idx = kOptFoldnestmax },
  { .name = "quoteescape", .opt_idx = kOptQuoteescape },
  { .name = "eadirection", .opt_idx = kOptEadirection },
  { .name = "viminfofile", .opt_idx = kOptShadafile },
  { .name = "rulerformat", .opt_idx = kOptRulerformat },
  { .name = "errorformat", .opt_idx = kOptErrorformat },
  { .name = "messagesopt", .opt_idx = kOptMessagesopt },
  { .name = "eventignore", .opt_idx = kOptEventignore },
  { .name = "breakindent", .opt_idx = kOptBreakindent },
  { .name = "smartindent", .opt_idx = kOptSmartindent },
  { .name = "loadplugins", .opt_idx = kOptLoadplugins },
  { .name = "tagrelative", .opt_idx = kOptTagrelative },
  { .name = "runtimepath", .opt_idx = kOptRuntimepath },
  { .name = "winminwidth", .opt_idx = kOptWinminwidth },
  { .name = "guifontwide", .opt_idx = kOptGuifontwide },
  { .name = "langnoremap", .opt_idx = kOptLangnoremap },
  { .name = "charconvert", .opt_idx = kOptCharconvert },
  { .name = "ttimeoutlen", .opt_idx = kOptTtimeoutlen },
  { .name = "startofline", .opt_idx = kOptStartofline },
  { .name = "fileformats", .opt_idx = kOptFileformats },
  { .name = "lispoptions", .opt_idx = kOptLispoptions },
  { .name = "maxmapdepth", .opt_idx = kOptMaxmapdepth },
  { .name = "jumpoptions", .opt_idx = kOptJumpoptions },
  { .name = "wildoptions", .opt_idx = kOptWildoptions },
  { .name = "viewoptions", .opt_idx = kOptViewoptions },
  { .name = "allowrevins", .opt_idx = kOptAllowrevins },
  { .name = "numberwidth", .opt_idx = kOptNumberwidth },
  { .name = "titlestring", .opt_idx = kOptTitlestring },
  { .name = "mousescroll", .opt_idx = kOptMousescroll },
  { .name = "verbosefile", .opt_idx = kOptVerbosefile },
  { .name = "pastetoggle", .opt_idx = kOptPastetoggle },
  { .name = "showfulltag", .opt_idx = kOptShowfulltag },
  { .name = "redrawdebug", .opt_idx = kOptRedrawdebug },
  { .name = "shellxquote", .opt_idx = kOptShellxquote },
  { .name = "pummaxwidth", .opt_idx = kOptPummaxwidth },
  { .name = "winfixwidth", .opt_idx = kOptWinfixwidth },
  { .name = "suffixesadd", .opt_idx = kOptSuffixesadd },
  { .name = "statuscolumn", .opt_idx = kOptStatuscolumn },
  { .name = "edcompatible", .opt_idx = kOptEdcompatible },
  { .name = "cmdwinheight", .opt_idx = kOptCmdwinheight },
  { .name = "modelineexpr", .opt_idx = kOptModelineexpr },
  { .name = "operatorfunc", .opt_idx = kOptOperatorfunc },
  { .name = "shellcmdflag", .opt_idx = kOptShellcmdflag },
  { .name = "spelloptions", .opt_idx = kOptSpelloptions },
  { .name = "spellsuggest", .opt_idx = kOptSpellsuggest },
  { .name = "shellxescape", .opt_idx = kOptShellxescape },
  { .name = "regexpengine", .opt_idx = kOptRegexpengine },
  { .name = "rightleftcmd", .opt_idx = kOptRightleftcmd },
  { .name = "makeencoding", .opt_idx = kOptMakeencoding },
  { .name = "foldminlines", .opt_idx = kOptFoldminlines },
  { .name = "fileencoding", .opt_idx = kOptFileencoding },
  { .name = "completefunc", .opt_idx = kOptCompletefunc },
  { .name = "winminheight", .opt_idx = kOptWinminheight },
  { .name = "conceallevel", .opt_idx = kOptConceallevel },
  { .name = "winhighlight", .opt_idx = kOptWinhighlight },
  { .name = "winfixheight", .opt_idx = kOptWinfixheight },
  { .name = "smoothscroll", .opt_idx = kOptSmoothscroll },
  { .name = "termencoding", .opt_idx = kOptTermencoding },
  { .name = "cursorcolumn", .opt_idx = kOptCursorcolumn },
  { .name = "autowriteall", .opt_idx = kOptAutowriteall },
  { .name = "maxfuncdepth", .opt_idx = kOptMaxfuncdepth },
  { .name = "fixendofline", .opt_idx = kOptFixendofline },
  { .name = "concealcursor", .opt_idx = kOptConcealcursor },
  { .name = "guitabtooltip", .opt_idx = kOptGuitabtooltip },
  { .name = "sidescrolloff", .opt_idx = kOptSidescrolloff },
  { .name = "spellcapcheck", .opt_idx = kOptSpellcapcheck },
  { .name = "completeslash", .opt_idx = kOptCompleteslash },
  { .name = "previewheight", .opt_idx = kOptPreviewheight },
  { .name = "previewwindow", .opt_idx = kOptPreviewwindow },
  { .name = "maxmempattern", .opt_idx = kOptMaxmempattern },
  { .name = "commentstring", .opt_idx = kOptCommentstring },
  { .name = "fileencodings", .opt_idx = kOptFileencodings },
  { .name = "cinscopedecls", .opt_idx = kOptCinscopedecls },
  { .name = "cursorlineopt", .opt_idx = kOptCursorlineopt },
  { .name = "formatoptions", .opt_idx = kOptFormatoptions },
  { .name = "formatlistpat", .opt_idx = kOptFormatlistpat },
  { .name = "termguicolors", .opt_idx = kOptTermguicolors },
  { .name = "thesaurusfunc", .opt_idx = kOptThesaurusfunc },
  { .name = "breakindentopt", .opt_idx = kOptBreakindentopt },
  { .name = "eventignorewin", .opt_idx = kOptEventignorewin },
  { .name = "foldlevelstart", .opt_idx = kOptFoldlevelstart },
  { .name = "fileignorecase", .opt_idx = kOptFileignorecase },
  { .name = "mousemoveevent", .opt_idx = kOptMousemoveevent },
  { .name = "preserveindent", .opt_idx = kOptPreserveindent },
  { .name = "relativenumber", .opt_idx = kOptRelativenumber },
  { .name = "sessionoptions", .opt_idx = kOptSessionoptions },
  { .name = "varsofttabstop", .opt_idx = kOptVarsofttabstop },
  { .name = "wildignorecase", .opt_idx = kOptWildignorecase },
  { .name = "termpastefilter", .opt_idx = kOptTermpastefilter },
  { .name = "quickfixtextfunc", .opt_idx = kOptQuickfixtextfunc },
  { .name = "completeitemalign", .opt_idx = kOptCompleteitemalign },
  { .name = "completefuzzycollect", .opt_idx = kOptCompletefuzzycollect },
};

static int find_option_hash(const char *str, size_t len)
{
  int low = 0, high = 0;
  switch (len) {
    case 2: switch (str[1]) {
      case 'a': low = 0; high = 4; break;
      case 'b': low = 4; high = 10; break;
      case 'c': low = 10; high = 16; break;
      case 'd': low = 16; high = 21; break;
      case 'e': low = 21; high = 24; break;
      case 'f': low = 24; high = 30; break;
      case 'g': low = 30; high = 32; break;
      case 'h': low = 32; high = 39; break;
      case 'i': low = 39; high = 48; break;
      case 'j': low = 48; high = 49; break;
      case 'k': low = 49; high = 51; break;
      case 'l': low = 51; high = 58; break;
      case 'm': low = 58; high = 65; break;
      case 'o': low = 65; high = 72; break;
      case 'p': low = 72; high = 80; break;
      case 'r': low = 80; high = 84; break;
      case 's': low = 84; high = 92; break;
      case 't': low = 92; high = 97; break;
      case 'u': low = 97; high = 100; break;
      case 'w': low = 100; high = 106; break;
      case 'x': low = 106; high = 107; break;
      case 'y': low = 107; high = 108; break;
      case 'z': low = 108; high = 109; break;
      default: break;
    }
    break;
    case 3: switch (str[2]) {
      case 'a': low = 109; high = 113; break;
      case 'b': low = 113; high = 118; break;
      case 'c': low = 118; high = 132; break;
      case 'd': low = 132; high = 140; break;
      case 'e': low = 140; high = 143; break;
      case 'f': low = 143; high = 155; break;
      case 'g': low = 155; high = 158; break;
      case 'h': low = 158; high = 163; break;
      case 'i': low = 163; high = 170; break;
      case 'k': low = 170; high = 175; break;
      case 'l': low = 175; high = 191; break;
      case 'm': low = 191; high = 204; break;
      case 'n': low = 204; high = 210; break;
      case 'o': low = 210; high = 216; break;
      case 'p': low = 216; high = 230; break;
      case 'q': low = 230; high = 232; break;
      case 'r': low = 232; high = 243; break;
      case 's': low = 243; high = 259; break;
      case 't': low = 259; high = 266; break;
      case 'u': low = 266; high = 271; break;
      case 'v': low = 271; high = 272; break;
      case 'w': low = 272; high = 280; break;
      case 'x': low = 280; high = 285; break;
      default: break;
    }
    break;
    case 4: switch (str[3]) {
      case 'a': low = 285; high = 286; break;
      case 'b': low = 286; high = 288; break;
      case 'c': low = 288; high = 293; break;
      case 'e': low = 293; high = 296; break;
      case 'f': low = 296; high = 299; break;
      case 'h': low = 299; high = 300; break;
      case 'k': low = 300; high = 303; break;
      case 'l': low = 303; high = 304; break;
      case 'n': low = 304; high = 306; break;
      case 'o': low = 306; high = 309; break;
      case 'p': low = 309; high = 314; break;
      case 'r': low = 314; high = 317; break;
      case 's': low = 317; high = 320; break;
      case 't': low = 320; high = 325; break;
      case 'u': low = 325; high = 327; break;
      case 'v': low = 327; high = 328; break;
      case 'w': low = 328; high = 330; break;
      case 'x': low = 330; high = 331; break;
      default: break;
    }
    break;
    case 5: switch (str[0]) {
      case 'a': low = 331; high = 332; break;
      case 'b': low = 332; high = 333; break;
      case 'c': low = 333; high = 335; break;
      case 'd': low = 335; high = 336; break;
      case 'e': low = 336; high = 337; break;
      case 'f': low = 337; high = 339; break;
      case 'h': low = 339; high = 340; break;
      case 'l': low = 340; high = 341; break;
      case 'm': low = 341; high = 343; break;
      case 'p': low = 343; high = 344; break;
      case 'r': low = 344; high = 346; break;
      case 's': low = 346; high = 349; break;
      case 't': low = 349; high = 353; break;
      case 'v': low = 353; high = 354; break;
      case 'w': low = 354; high = 357; break;
      default: break;
    }
    break;
    case 6: switch (str[2]) {
      case 'a': low = 357; high = 358; break;
      case 'c': low = 358; high = 360; break;
      case 'd': low = 360; high = 361; break;
      case 'f': low = 361; high = 363; break;
      case 'h': low = 363; high = 364; break;
      case 'i': low = 364; high = 365; break;
      case 'k': low = 365; high = 366; break;
      case 'l': low = 366; high = 367; break;
      case 'm': low = 367; high = 369; break;
      case 'n': low = 369; high = 373; break;
      case 'o': low = 373; high = 374; break;
      case 'p': low = 374; high = 376; break;
      case 'r': low = 376; high = 377; break;
      case 'u': low = 377; high = 381; break;
      case 'v': low = 381; high = 382; break;
      case 'x': low = 382; high = 383; break;
      case 'y': low = 383; high = 384; break;
      default: break;
    }
    break;
    case 7: switch (str[2]) {
      case 'a': low = 384; high = 385; break;
      case 'b': low = 385; high = 387; break;
      case 'c': low = 387; high = 388; break;
      case 'd': low = 388; high = 389; break;
      case 'e': low = 389; high = 392; break;
      case 'f': low = 392; high = 395; break;
      case 'g': low = 395; high = 398; break;
      case 'i': low = 398; high = 400; break;
      case 'k': low = 400; high = 401; break;
      case 'l': low = 401; high = 404; break;
      case 'm': low = 404; high = 406; break;
      case 'n': low = 406; high = 410; break;
      case 'o': low = 410; high = 411; break;
      case 'p': low = 411; high = 412; break;
      case 'r': low = 412; high = 413; break;
      case 's': low = 413; high = 417; break;
      case 'y': low = 417; high = 418; break;
      default: break;
    }
    break;
    case 8: switch (str[0]) {
      case 'a': low = 418; high = 419; break;
      case 'c': low = 419; high = 423; break;
      case 'd': low = 423; high = 424; break;
      case 'e': low = 424; high = 426; break;
      case 'f': low = 426; high = 431; break;
      case 'g': low = 431; high = 432; break;
      case 'h': low = 432; high = 435; break;
      case 'i': low = 435; high = 437; break;
      case 'k': low = 437; high = 438; break;
      case 'l': low = 438; high = 440; break;
      case 'm': low = 440; high = 443; break;
      case 'o': low = 443; high = 444; break;
      case 'p': low = 444; high = 447; break;
      case 'r': low = 447; high = 448; break;
      case 's': low = 448; high = 453; break;
      case 't': low = 453; high = 460; break;
      case 'u': low = 460; high = 461; break;
      case 'w': low = 461; high = 468; break;
      default: break;
    }
    break;
    case 9: switch (str[7]) {
      case 'a': low = 468; high = 473; break;
      case 'c': low = 473; high = 477; break;
      case 'd': low = 477; high = 480; break;
      case 'e': low = 480; high = 486; break;
      case 'f': low = 486; high = 488; break;
      case 'h': low = 488; high = 492; break;
      case 'i': low = 492; high = 495; break;
      case 'l': low = 495; high = 500; break;
      case 'm': low = 500; high = 504; break;
      case 'n': low = 504; high = 508; break;
      case 'o': low = 508; high = 511; break;
      case 'p': low = 511; high = 514; break;
      case 'r': low = 514; high = 521; break;
      case 's': low = 521; high = 525; break;
      case 't': low = 525; high = 530; break;
      case 'u': low = 530; high = 533; break;
      case 'x': low = 533; high = 534; break;
      default: break;
    }
    break;
    case 10: switch (str[6]) {
      case 'a': low = 534; high = 541; break;
      case 'b': low = 541; high = 547; break;
      case 'c': low = 547; high = 549; break;
      case 'd': low = 549; high = 554; break;
      case 'e': low = 554; high = 561; break;
      case 'h': low = 561; high = 562; break;
      case 'i': low = 562; high = 568; break;
      case 'j': low = 568; high = 569; break;
      case 'k': low = 569; high = 571; break;
      case 'l': low = 571; high = 578; break;
      case 'm': low = 578; high = 581; break;
      case 'n': low = 581; high = 584; break;
      case 'o': low = 584; high = 588; break;
      case 'r': low = 588; high = 594; break;
      case 's': low = 594; high = 597; break;
      case 't': low = 597; high = 601; break;
      case 'u': low = 601; high = 602; break;
      case 'v': low = 602; high = 604; break;
      default: break;
    }
    break;
    case 11: switch (str[5]) {
      case 'a': low = 604; high = 608; break;
      case 'b': low = 608; high = 610; break;
      case 'c': low = 610; high = 612; break;
      case 'd': low = 612; high = 613; break;
      case 'e': low = 613; high = 618; break;
      case 'f': low = 618; high = 621; break;
      case 'g': low = 621; high = 622; break;
      case 'i': low = 622; high = 625; break;
      case 'l': low = 625; high = 627; break;
      case 'm': low = 627; high = 628; break;
      case 'n': low = 628; high = 630; break;
      case 'o': low = 630; high = 635; break;
      case 'p': low = 635; high = 640; break;
      case 'r': low = 640; high = 642; break;
      case 's': low = 642; high = 645; break;
      case 't': low = 645; high = 646; break;
      case 'u': low = 646; high = 647; break;
      case 'w': low = 647; high = 648; break;
      case 'x': low = 648; high = 652; break;
      default: break;
    }
    break;
    case 12: switch (str[2]) {
      case 'a': low = 652; high = 653; break;
      case 'c': low = 653; high = 654; break;
      case 'd': low = 654; high = 656; break;
      case 'e': low = 656; high = 661; break;
      case 'g': low = 661; high = 663; break;
      case 'k': low = 663; high = 664; break;
      case 'l': low = 664; high = 666; break;
      case 'm': low = 666; high = 667; break;
      case 'n': low = 667; high = 671; break;
      case 'o': low = 671; high = 672; break;
      case 'r': low = 672; high = 674; break;
      case 't': low = 674; high = 675; break;
      case 'x': low = 675; high = 677; break;
      default: break;
    }
    break;
    case 13: switch (str[5]) {
      case 'a': low = 677; high = 678; break;
      case 'b': low = 678; high = 679; break;
      case 'c': low = 679; high = 681; break;
      case 'e': low = 681; high = 684; break;
      case 'm': low = 684; high = 685; break;
      case 'n': low = 685; high = 687; break;
      case 'o': low = 687; high = 688; break;
      case 'r': low = 688; high = 689; break;
      case 't': low = 689; high = 691; break;
      case 'u': low = 691; high = 693; break;
      default: break;
    }
    break;
    case 14: switch (str[0]) {
      case 'b': low = 693; high = 694; break;
      case 'e': low = 694; high = 695; break;
      case 'f': low = 695; high = 697; break;
      case 'm': low = 697; high = 698; break;
      case 'p': low = 698; high = 699; break;
      case 'r': low = 699; high = 700; break;
      case 's': low = 700; high = 701; break;
      case 'v': low = 701; high = 702; break;
      case 'w': low = 702; high = 703; break;
      default: break;
    }
    break;
    case 15: low = 703; high = 704; break;
    case 16: low = 704; high = 705; break;
    case 17: low = 705; high = 706; break;
    case 20: low = 706; high = 707; break;
    default: break;
  }
  for (int i = low; i < high; i++) {
    if (!memcmp(str, option_hash_elems[i].name, len)) {
      return i;
    }
  }
  return -1;
}


