// IWYU pragma: private, include "nvim/option_defs.h"

typedef enum {
  kOptInvalid = -1,
  kOptAleph = 0,
  kOptAllowrevins = 1,
  kOptAmbiwidth = 2,
  kOptArabic = 3,
  kOptArabicshape = 4,
  kOptAutochdir = 5,
  kOptAutoindent = 6,
  kOptAutoread = 7,
  kOptAutowrite = 8,
  kOptAutowriteall = 9,
  kOptBackground = 10,
  kOptBackspace = 11,
  kOptBackup = 12,
  kOptBackupcopy = 13,
  kOptBackupdir = 14,
  kOptBackupext = 15,
  kOptBackupskip = 16,
  kOptBelloff = 17,
  kOptBinary = 18,
  kOptBomb = 19,
  kOptBreakat = 20,
  kOptBreakindent = 21,
  kOptBreakindentopt = 22,
  kOptBrowsedir = 23,
  kOptBufhidden = 24,
  kOptBuflisted = 25,
  kOptBuftype = 26,
  kOptCasemap = 27,
  kOptCdhome = 28,
  kOptCdpath = 29,
  kOptCedit = 30,
  kOptChannel = 31,
  kOptCharconvert = 32,
  kOptChistory = 33,
  kOptCindent = 34,
  kOptCinkeys = 35,
  kOptCinoptions = 36,
  kOptCinscopedecls = 37,
  kOptCinwords = 38,
  kOptClipboard = 39,
  kOptCmdheight = 40,
  kOptCmdwinheight = 41,
  kOptColorcolumn = 42,
  kOptColumns = 43,
  kOptComments = 44,
  kOptCommentstring = 45,
  kOptCompatible = 46,
  kOptComplete = 47,
  kOptCompletefunc = 48,
  kOptCompletefuzzycollect = 49,
  kOptCompleteitemalign = 50,
  kOptCompleteopt = 51,
  kOptCompleteslash = 52,
  kOptConcealcursor = 53,
  kOptConceallevel = 54,
  kOptConfirm = 55,
  kOptCopyindent = 56,
  kOptCpoptions = 57,
  kOptCursorbind = 58,
  kOptCursorcolumn = 59,
  kOptCursorline = 60,
  kOptCursorlineopt = 61,
  kOptDebug = 62,
  kOptDefine = 63,
  kOptDelcombine = 64,
  kOptDictionary = 65,
  kOptDiff = 66,
  kOptDiffexpr = 67,
  kOptDiffopt = 68,
  kOptDigraph = 69,
  kOptDirectory = 70,
  kOptDisplay = 71,
  kOptEadirection = 72,
  kOptEdcompatible = 73,
  kOptEmoji = 74,
  kOptEncoding = 75,
  kOptEndoffile = 76,
  kOptEndofline = 77,
  kOptEqualalways = 78,
  kOptEqualprg = 79,
  kOptErrorbells = 80,
  kOptErrorfile = 81,
  kOptErrorformat = 82,
  kOptEventignore = 83,
  kOptEventignorewin = 84,
  kOptExpandtab = 85,
  kOptExrc = 86,
  kOptFileencoding = 87,
  kOptFileencodings = 88,
  kOptFileformat = 89,
  kOptFileformats = 90,
  kOptFileignorecase = 91,
  kOptFiletype = 92,
  kOptFillchars = 93,
  kOptFindfunc = 94,
  kOptFixendofline = 95,
  kOptFoldclose = 96,
  kOptFoldcolumn = 97,
  kOptFoldenable = 98,
  kOptFoldexpr = 99,
  kOptFoldignore = 100,
  kOptFoldlevel = 101,
  kOptFoldlevelstart = 102,
  kOptFoldmarker = 103,
  kOptFoldmethod = 104,
  kOptFoldminlines = 105,
  kOptFoldnestmax = 106,
  kOptFoldopen = 107,
  kOptFoldtext = 108,
  kOptFormatexpr = 109,
  kOptFormatlistpat = 110,
  kOptFormatoptions = 111,
  kOptFormatprg = 112,
  kOptFsync = 113,
  kOptGdefault = 114,
  kOptGrepformat = 115,
  kOptGrepprg = 116,
  kOptGuicursor = 117,
  kOptGuifont = 118,
  kOptGuifontwide = 119,
  kOptGuioptions = 120,
  kOptGuitablabel = 121,
  kOptGuitabtooltip = 122,
  kOptHelpfile = 123,
  kOptHelpheight = 124,
  kOptHelplang = 125,
  kOptHidden = 126,
  kOptHighlight = 127,
  kOptHistory = 128,
  kOptHkmap = 129,
  kOptHkmapp = 130,
  kOptHlsearch = 131,
  kOptIcon = 132,
  kOptIconstring = 133,
  kOptIgnorecase = 134,
  kOptImcmdline = 135,
  kOptImdisable = 136,
  kOptIminsert = 137,
  kOptImsearch = 138,
  kOptInccommand = 139,
  kOptInclude = 140,
  kOptIncludeexpr = 141,
  kOptIncsearch = 142,
  kOptIndentexpr = 143,
  kOptIndentkeys = 144,
  kOptInfercase = 145,
  kOptInsertmode = 146,
  kOptIsfname = 147,
  kOptIsident = 148,
  kOptIskeyword = 149,
  kOptIsprint = 150,
  kOptJoinspaces = 151,
  kOptJumpoptions = 152,
  kOptKeymap = 153,
  kOptKeymodel = 154,
  kOptKeywordprg = 155,
  kOptLangmap = 156,
  kOptLangmenu = 157,
  kOptLangnoremap = 158,
  kOptLangremap = 159,
  kOptLaststatus = 160,
  kOptLazyredraw = 161,
  kOptLhistory = 162,
  kOptLinebreak = 163,
  kOptLines = 164,
  kOptLinespace = 165,
  kOptLisp = 166,
  kOptLispoptions = 167,
  kOptLispwords = 168,
  kOptList = 169,
  kOptListchars = 170,
  kOptLoadplugins = 171,
  kOptMagic = 172,
  kOptMakeef = 173,
  kOptMakeencoding = 174,
  kOptMakeprg = 175,
  kOptMatchpairs = 176,
  kOptMatchtime = 177,
  kOptMaxcombine = 178,
  kOptMaxfuncdepth = 179,
  kOptMaxmapdepth = 180,
  kOptMaxmempattern = 181,
  kOptMenuitems = 182,
  kOptMessagesopt = 183,
  kOptMkspellmem = 184,
  kOptModeline = 185,
  kOptModelineexpr = 186,
  kOptModelines = 187,
  kOptModifiable = 188,
  kOptModified = 189,
  kOptMore = 190,
  kOptMouse = 191,
  kOptMousefocus = 192,
  kOptMousehide = 193,
  kOptMousemodel = 194,
  kOptMousemoveevent = 195,
  kOptMousescroll = 196,
  kOptMouseshape = 197,
  kOptMousetime = 198,
  kOptNrformats = 199,
  kOptNumber = 200,
  kOptNumberwidth = 201,
  kOptOmnifunc = 202,
  kOptOpendevice = 203,
  kOptOperatorfunc = 204,
  kOptPackpath = 205,
  kOptParagraphs = 206,
  kOptPaste = 207,
  kOptPastetoggle = 208,
  kOptPatchexpr = 209,
  kOptPatchmode = 210,
  kOptPath = 211,
  kOptPreserveindent = 212,
  kOptPreviewheight = 213,
  kOptPreviewwindow = 214,
  kOptPrompt = 215,
  kOptPumblend = 216,
  kOptPumheight = 217,
  kOptPummaxwidth = 218,
  kOptPumwidth = 219,
  kOptPyxversion = 220,
  kOptQuickfixtextfunc = 221,
  kOptQuoteescape = 222,
  kOptReadonly = 223,
  kOptRedrawdebug = 224,
  kOptRedrawtime = 225,
  kOptRegexpengine = 226,
  kOptRelativenumber = 227,
  kOptRemap = 228,
  kOptReport = 229,
  kOptRevins = 230,
  kOptRightleft = 231,
  kOptRightleftcmd = 232,
  kOptRuler = 233,
  kOptRulerformat = 234,
  kOptRuntimepath = 235,
  kOptScroll = 236,
  kOptScrollback = 237,
  kOptScrollbind = 238,
  kOptScrolljump = 239,
  kOptScrolloff = 240,
  kOptScrollopt = 241,
  kOptSections = 242,
  kOptSecure = 243,
  kOptSelection = 244,
  kOptSelectmode = 245,
  kOptSessionoptions = 246,
  kOptShada = 247,
  kOptShadafile = 248,
  kOptShell = 249,
  kOptShellcmdflag = 250,
  kOptShellpipe = 251,
  kOptShellquote = 252,
  kOptShellredir = 253,
  kOptShellslash = 254,
  kOptShelltemp = 255,
  kOptShellxescape = 256,
  kOptShellxquote = 257,
  kOptShiftround = 258,
  kOptShiftwidth = 259,
  kOptShortmess = 260,
  kOptShowbreak = 261,
  kOptShowcmd = 262,
  kOptShowcmdloc = 263,
  kOptShowfulltag = 264,
  kOptShowmatch = 265,
  kOptShowmode = 266,
  kOptShowtabline = 267,
  kOptSidescroll = 268,
  kOptSidescrolloff = 269,
  kOptSigncolumn = 270,
  kOptSmartcase = 271,
  kOptSmartindent = 272,
  kOptSmarttab = 273,
  kOptSmoothscroll = 274,
  kOptSofttabstop = 275,
  kOptSpell = 276,
  kOptSpellcapcheck = 277,
  kOptSpellfile = 278,
  kOptSpelllang = 279,
  kOptSpelloptions = 280,
  kOptSpellsuggest = 281,
  kOptSplitbelow = 282,
  kOptSplitkeep = 283,
  kOptSplitright = 284,
  kOptStartofline = 285,
  kOptStatuscolumn = 286,
  kOptStatusline = 287,
  kOptSuffixes = 288,
  kOptSuffixesadd = 289,
  kOptSwapfile = 290,
  kOptSwitchbuf = 291,
  kOptSynmaxcol = 292,
  kOptSyntax = 293,
  kOptTabclose = 294,
  kOptTabline = 295,
  kOptTabpagemax = 296,
  kOptTabstop = 297,
  kOptTagbsearch = 298,
  kOptTagcase = 299,
  kOptTagfunc = 300,
  kOptTaglength = 301,
  kOptTagrelative = 302,
  kOptTags = 303,
  kOptTagstack = 304,
  kOptTermbidi = 305,
  kOptTermencoding = 306,
  kOptTermguicolors = 307,
  kOptTermpastefilter = 308,
  kOptTermsync = 309,
  kOptTerse = 310,
  kOptTextwidth = 311,
  kOptThesaurus = 312,
  kOptThesaurusfunc = 313,
  kOptTildeop = 314,
  kOptTimeout = 315,
  kOptTimeoutlen = 316,
  kOptTitle = 317,
  kOptTitlelen = 318,
  kOptTitleold = 319,
  kOptTitlestring = 320,
  kOptTtimeout = 321,
  kOptTtimeoutlen = 322,
  kOptTtyfast = 323,
  kOptUndodir = 324,
  kOptUndofile = 325,
  kOptUndolevels = 326,
  kOptUndoreload = 327,
  kOptUpdatecount = 328,
  kOptUpdatetime = 329,
  kOptVarsofttabstop = 330,
  kOptVartabstop = 331,
  kOptVerbose = 332,
  kOptVerbosefile = 333,
  kOptViewdir = 334,
  kOptViewoptions = 335,
  kOptVirtualedit = 336,
  kOptVisualbell = 337,
  kOptWarn = 338,
  kOptWhichwrap = 339,
  kOptWildchar = 340,
  kOptWildcharm = 341,
  kOptWildignore = 342,
  kOptWildignorecase = 343,
  kOptWildmenu = 344,
  kOptWildmode = 345,
  kOptWildoptions = 346,
  kOptWinaltkeys = 347,
  kOptWinbar = 348,
  kOptWinblend = 349,
  kOptWinborder = 350,
  kOptWindow = 351,
  kOptWinfixbuf = 352,
  kOptWinfixheight = 353,
  kOptWinfixwidth = 354,
  kOptWinheight = 355,
  kOptWinhighlight = 356,
  kOptWinminheight = 357,
  kOptWinminwidth = 358,
  kOptWinwidth = 359,
  kOptWrap = 360,
  kOptWrapmargin = 361,
  kOptWrapscan = 362,
  kOptWrite = 363,
  kOptWriteany = 364,
  kOptWritebackup = 365,
  kOptWritedelay = 366,
  // Option count
#define kOptCount 367
} OptIndex;

typedef enum {
  kGlobalOptInvalid = -1,
  kGlobalOptAleph = 0,
  kGlobalOptAllowrevins = 1,
  kGlobalOptAmbiwidth = 2,
  kGlobalOptArabicshape = 3,
  kGlobalOptAutochdir = 4,
  kGlobalOptAutoread = 5,
  kGlobalOptAutowrite = 6,
  kGlobalOptAutowriteall = 7,
  kGlobalOptBackground = 8,
  kGlobalOptBackspace = 9,
  kGlobalOptBackup = 10,
  kGlobalOptBackupcopy = 11,
  kGlobalOptBackupdir = 12,
  kGlobalOptBackupext = 13,
  kGlobalOptBackupskip = 14,
  kGlobalOptBelloff = 15,
  kGlobalOptBreakat = 16,
  kGlobalOptBrowsedir = 17,
  kGlobalOptCasemap = 18,
  kGlobalOptCdhome = 19,
  kGlobalOptCdpath = 20,
  kGlobalOptCedit = 21,
  kGlobalOptCharconvert = 22,
  kGlobalOptChistory = 23,
  kGlobalOptClipboard = 24,
  kGlobalOptCmdheight = 25,
  kGlobalOptCmdwinheight = 26,
  kGlobalOptColumns = 27,
  kGlobalOptCompatible = 28,
  kGlobalOptCompletefuzzycollect = 29,
  kGlobalOptCompleteitemalign = 30,
  kGlobalOptCompleteopt = 31,
  kGlobalOptConfirm = 32,
  kGlobalOptCpoptions = 33,
  kGlobalOptDebug = 34,
  kGlobalOptDefine = 35,
  kGlobalOptDelcombine = 36,
  kGlobalOptDictionary = 37,
  kGlobalOptDiffexpr = 38,
  kGlobalOptDiffopt = 39,
  kGlobalOptDigraph = 40,
  kGlobalOptDirectory = 41,
  kGlobalOptDisplay = 42,
  kGlobalOptEadirection = 43,
  kGlobalOptEdcompatible = 44,
  kGlobalOptEmoji = 45,
  kGlobalOptEncoding = 46,
  kGlobalOptEqualalways = 47,
  kGlobalOptEqualprg = 48,
  kGlobalOptErrorbells = 49,
  kGlobalOptErrorfile = 50,
  kGlobalOptErrorformat = 51,
  kGlobalOptEventignore = 52,
  kGlobalOptExrc = 53,
  kGlobalOptFileencodings = 54,
  kGlobalOptFileformats = 55,
  kGlobalOptFileignorecase = 56,
  kGlobalOptFillchars = 57,
  kGlobalOptFindfunc = 58,
  kGlobalOptFoldclose = 59,
  kGlobalOptFoldlevelstart = 60,
  kGlobalOptFoldopen = 61,
  kGlobalOptFormatprg = 62,
  kGlobalOptFsync = 63,
  kGlobalOptGdefault = 64,
  kGlobalOptGrepformat = 65,
  kGlobalOptGrepprg = 66,
  kGlobalOptGuicursor = 67,
  kGlobalOptGuifont = 68,
  kGlobalOptGuifontwide = 69,
  kGlobalOptGuioptions = 70,
  kGlobalOptGuitablabel = 71,
  kGlobalOptGuitabtooltip = 72,
  kGlobalOptHelpfile = 73,
  kGlobalOptHelpheight = 74,
  kGlobalOptHelplang = 75,
  kGlobalOptHidden = 76,
  kGlobalOptHighlight = 77,
  kGlobalOptHistory = 78,
  kGlobalOptHkmap = 79,
  kGlobalOptHkmapp = 80,
  kGlobalOptHlsearch = 81,
  kGlobalOptIcon = 82,
  kGlobalOptIconstring = 83,
  kGlobalOptIgnorecase = 84,
  kGlobalOptImcmdline = 85,
  kGlobalOptImdisable = 86,
  kGlobalOptInccommand = 87,
  kGlobalOptInclude = 88,
  kGlobalOptIncsearch = 89,
  kGlobalOptInsertmode = 90,
  kGlobalOptIsfname = 91,
  kGlobalOptIsident = 92,
  kGlobalOptIsprint = 93,
  kGlobalOptJoinspaces = 94,
  kGlobalOptJumpoptions = 95,
  kGlobalOptKeymodel = 96,
  kGlobalOptKeywordprg = 97,
  kGlobalOptLangmap = 98,
  kGlobalOptLangmenu = 99,
  kGlobalOptLangnoremap = 100,
  kGlobalOptLangremap = 101,
  kGlobalOptLaststatus = 102,
  kGlobalOptLazyredraw = 103,
  kGlobalOptLines = 104,
  kGlobalOptLinespace = 105,
  kGlobalOptLispwords = 106,
  kGlobalOptListchars = 107,
  kGlobalOptLoadplugins = 108,
  kGlobalOptMagic = 109,
  kGlobalOptMakeef = 110,
  kGlobalOptMakeencoding = 111,
  kGlobalOptMakeprg = 112,
  kGlobalOptMatchtime = 113,
  kGlobalOptMaxcombine = 114,
  kGlobalOptMaxfuncdepth = 115,
  kGlobalOptMaxmapdepth = 116,
  kGlobalOptMaxmempattern = 117,
  kGlobalOptMenuitems = 118,
  kGlobalOptMessagesopt = 119,
  kGlobalOptMkspellmem = 120,
  kGlobalOptModelineexpr = 121,
  kGlobalOptModelines = 122,
  kGlobalOptMore = 123,
  kGlobalOptMouse = 124,
  kGlobalOptMousefocus = 125,
  kGlobalOptMousehide = 126,
  kGlobalOptMousemodel = 127,
  kGlobalOptMousemoveevent = 128,
  kGlobalOptMousescroll = 129,
  kGlobalOptMouseshape = 130,
  kGlobalOptMousetime = 131,
  kGlobalOptOpendevice = 132,
  kGlobalOptOperatorfunc = 133,
  kGlobalOptPackpath = 134,
  kGlobalOptParagraphs = 135,
  kGlobalOptPaste = 136,
  kGlobalOptPastetoggle = 137,
  kGlobalOptPatchexpr = 138,
  kGlobalOptPatchmode = 139,
  kGlobalOptPath = 140,
  kGlobalOptPreviewheight = 141,
  kGlobalOptPrompt = 142,
  kGlobalOptPumblend = 143,
  kGlobalOptPumheight = 144,
  kGlobalOptPummaxwidth = 145,
  kGlobalOptPumwidth = 146,
  kGlobalOptPyxversion = 147,
  kGlobalOptQuickfixtextfunc = 148,
  kGlobalOptRedrawdebug = 149,
  kGlobalOptRedrawtime = 150,
  kGlobalOptRegexpengine = 151,
  kGlobalOptRemap = 152,
  kGlobalOptReport = 153,
  kGlobalOptRevins = 154,
  kGlobalOptRuler = 155,
  kGlobalOptRulerformat = 156,
  kGlobalOptRuntimepath = 157,
  kGlobalOptScrolljump = 158,
  kGlobalOptScrolloff = 159,
  kGlobalOptScrollopt = 160,
  kGlobalOptSections = 161,
  kGlobalOptSecure = 162,
  kGlobalOptSelection = 163,
  kGlobalOptSelectmode = 164,
  kGlobalOptSessionoptions = 165,
  kGlobalOptShada = 166,
  kGlobalOptShadafile = 167,
  kGlobalOptShell = 168,
  kGlobalOptShellcmdflag = 169,
  kGlobalOptShellpipe = 170,
  kGlobalOptShellquote = 171,
  kGlobalOptShellredir = 172,
  kGlobalOptShellslash = 173,
  kGlobalOptShelltemp = 174,
  kGlobalOptShellxescape = 175,
  kGlobalOptShellxquote = 176,
  kGlobalOptShiftround = 177,
  kGlobalOptShortmess = 178,
  kGlobalOptShowbreak = 179,
  kGlobalOptShowcmd = 180,
  kGlobalOptShowcmdloc = 181,
  kGlobalOptShowfulltag = 182,
  kGlobalOptShowmatch = 183,
  kGlobalOptShowmode = 184,
  kGlobalOptShowtabline = 185,
  kGlobalOptSidescroll = 186,
  kGlobalOptSidescrolloff = 187,
  kGlobalOptSmartcase = 188,
  kGlobalOptSmarttab = 189,
  kGlobalOptSpellsuggest = 190,
  kGlobalOptSplitbelow = 191,
  kGlobalOptSplitkeep = 192,
  kGlobalOptSplitright = 193,
  kGlobalOptStartofline = 194,
  kGlobalOptStatusline = 195,
  kGlobalOptSuffixes = 196,
  kGlobalOptSwitchbuf = 197,
  kGlobalOptTabclose = 198,
  kGlobalOptTabline = 199,
  kGlobalOptTabpagemax = 200,
  kGlobalOptTagbsearch = 201,
  kGlobalOptTagcase = 202,
  kGlobalOptTaglength = 203,
  kGlobalOptTagrelative = 204,
  kGlobalOptTags = 205,
  kGlobalOptTagstack = 206,
  kGlobalOptTermbidi = 207,
  kGlobalOptTermencoding = 208,
  kGlobalOptTermguicolors = 209,
  kGlobalOptTermpastefilter = 210,
  kGlobalOptTermsync = 211,
  kGlobalOptTerse = 212,
  kGlobalOptThesaurus = 213,
  kGlobalOptThesaurusfunc = 214,
  kGlobalOptTildeop = 215,
  kGlobalOptTimeout = 216,
  kGlobalOptTimeoutlen = 217,
  kGlobalOptTitle = 218,
  kGlobalOptTitlelen = 219,
  kGlobalOptTitleold = 220,
  kGlobalOptTitlestring = 221,
  kGlobalOptTtimeout = 222,
  kGlobalOptTtimeoutlen = 223,
  kGlobalOptTtyfast = 224,
  kGlobalOptUndodir = 225,
  kGlobalOptUndolevels = 226,
  kGlobalOptUndoreload = 227,
  kGlobalOptUpdatecount = 228,
  kGlobalOptUpdatetime = 229,
  kGlobalOptVerbose = 230,
  kGlobalOptVerbosefile = 231,
  kGlobalOptViewdir = 232,
  kGlobalOptViewoptions = 233,
  kGlobalOptVirtualedit = 234,
  kGlobalOptVisualbell = 235,
  kGlobalOptWarn = 236,
  kGlobalOptWhichwrap = 237,
  kGlobalOptWildchar = 238,
  kGlobalOptWildcharm = 239,
  kGlobalOptWildignore = 240,
  kGlobalOptWildignorecase = 241,
  kGlobalOptWildmenu = 242,
  kGlobalOptWildmode = 243,
  kGlobalOptWildoptions = 244,
  kGlobalOptWinaltkeys = 245,
  kGlobalOptWinbar = 246,
  kGlobalOptWinborder = 247,
  kGlobalOptWindow = 248,
  kGlobalOptWinheight = 249,
  kGlobalOptWinminheight = 250,
  kGlobalOptWinminwidth = 251,
  kGlobalOptWinwidth = 252,
  kGlobalOptWrapscan = 253,
  kGlobalOptWrite = 254,
  kGlobalOptWriteany = 255,
  kGlobalOptWritebackup = 256,
  kGlobalOptWritedelay = 257,
  // Global option count
#define kGlobalOptCount 258
} GlobalOptIndex;

typedef enum {
  kBufOptInvalid = -1,
  kBufOptAutoindent = 0,
  kBufOptAutoread = 1,
  kBufOptBackupcopy = 2,
  kBufOptBinary = 3,
  kBufOptBomb = 4,
  kBufOptBufhidden = 5,
  kBufOptBuflisted = 6,
  kBufOptBuftype = 7,
  kBufOptChannel = 8,
  kBufOptCindent = 9,
  kBufOptCinkeys = 10,
  kBufOptCinoptions = 11,
  kBufOptCinscopedecls = 12,
  kBufOptCinwords = 13,
  kBufOptComments = 14,
  kBufOptCommentstring = 15,
  kBufOptComplete = 16,
  kBufOptCompletefunc = 17,
  kBufOptCompleteopt = 18,
  kBufOptCompleteslash = 19,
  kBufOptCopyindent = 20,
  kBufOptDefine = 21,
  kBufOptDictionary = 22,
  kBufOptEndoffile = 23,
  kBufOptEndofline = 24,
  kBufOptEqualprg = 25,
  kBufOptErrorformat = 26,
  kBufOptExpandtab = 27,
  kBufOptFileencoding = 28,
  kBufOptFileformat = 29,
  kBufOptFiletype = 30,
  kBufOptFindfunc = 31,
  kBufOptFixendofline = 32,
  kBufOptFormatexpr = 33,
  kBufOptFormatlistpat = 34,
  kBufOptFormatoptions = 35,
  kBufOptFormatprg = 36,
  kBufOptGrepprg = 37,
  kBufOptIminsert = 38,
  kBufOptImsearch = 39,
  kBufOptInclude = 40,
  kBufOptIncludeexpr = 41,
  kBufOptIndentexpr = 42,
  kBufOptIndentkeys = 43,
  kBufOptInfercase = 44,
  kBufOptIskeyword = 45,
  kBufOptKeymap = 46,
  kBufOptKeywordprg = 47,
  kBufOptLisp = 48,
  kBufOptLispoptions = 49,
  kBufOptLispwords = 50,
  kBufOptMakeencoding = 51,
  kBufOptMakeprg = 52,
  kBufOptMatchpairs = 53,
  kBufOptModeline = 54,
  kBufOptModifiable = 55,
  kBufOptModified = 56,
  kBufOptNrformats = 57,
  kBufOptOmnifunc = 58,
  kBufOptPath = 59,
  kBufOptPreserveindent = 60,
  kBufOptQuoteescape = 61,
  kBufOptReadonly = 62,
  kBufOptScrollback = 63,
  kBufOptShiftwidth = 64,
  kBufOptSmartindent = 65,
  kBufOptSofttabstop = 66,
  kBufOptSpellcapcheck = 67,
  kBufOptSpellfile = 68,
  kBufOptSpelllang = 69,
  kBufOptSpelloptions = 70,
  kBufOptSuffixesadd = 71,
  kBufOptSwapfile = 72,
  kBufOptSynmaxcol = 73,
  kBufOptSyntax = 74,
  kBufOptTabstop = 75,
  kBufOptTagcase = 76,
  kBufOptTagfunc = 77,
  kBufOptTags = 78,
  kBufOptTextwidth = 79,
  kBufOptThesaurus = 80,
  kBufOptThesaurusfunc = 81,
  kBufOptUndofile = 82,
  kBufOptUndolevels = 83,
  kBufOptVarsofttabstop = 84,
  kBufOptVartabstop = 85,
  kBufOptWrapmargin = 86,
  // Buf option count
#define kBufOptCount 87
} BufOptIndex;

typedef enum {
  kWinOptInvalid = -1,
  kWinOptArabic = 0,
  kWinOptBreakindent = 1,
  kWinOptBreakindentopt = 2,
  kWinOptColorcolumn = 3,
  kWinOptConcealcursor = 4,
  kWinOptConceallevel = 5,
  kWinOptCursorbind = 6,
  kWinOptCursorcolumn = 7,
  kWinOptCursorline = 8,
  kWinOptCursorlineopt = 9,
  kWinOptDiff = 10,
  kWinOptEventignorewin = 11,
  kWinOptFillchars = 12,
  kWinOptFoldcolumn = 13,
  kWinOptFoldenable = 14,
  kWinOptFoldexpr = 15,
  kWinOptFoldignore = 16,
  kWinOptFoldlevel = 17,
  kWinOptFoldmarker = 18,
  kWinOptFoldmethod = 19,
  kWinOptFoldminlines = 20,
  kWinOptFoldnestmax = 21,
  kWinOptFoldtext = 22,
  kWinOptLhistory = 23,
  kWinOptLinebreak = 24,
  kWinOptList = 25,
  kWinOptListchars = 26,
  kWinOptNumber = 27,
  kWinOptNumberwidth = 28,
  kWinOptPreviewwindow = 29,
  kWinOptRelativenumber = 30,
  kWinOptRightleft = 31,
  kWinOptRightleftcmd = 32,
  kWinOptScroll = 33,
  kWinOptScrollbind = 34,
  kWinOptScrolloff = 35,
  kWinOptShowbreak = 36,
  kWinOptSidescrolloff = 37,
  kWinOptSigncolumn = 38,
  kWinOptSmoothscroll = 39,
  kWinOptSpell = 40,
  kWinOptStatuscolumn = 41,
  kWinOptStatusline = 42,
  kWinOptVirtualedit = 43,
  kWinOptWinbar = 44,
  kWinOptWinblend = 45,
  kWinOptWinfixbuf = 46,
  kWinOptWinfixheight = 47,
  kWinOptWinfixwidth = 48,
  kWinOptWinhighlight = 49,
  kWinOptWrap = 50,
  // Win option count
#define kWinOptCount 51
} WinOptIndex;

EXTERN const OptIndex global_opt_idx[] INIT( = {
  [kGlobalOptAleph] = kOptAleph,
  [kGlobalOptAllowrevins] = kOptAllowrevins,
  [kGlobalOptAmbiwidth] = kOptAmbiwidth,
  [kGlobalOptArabicshape] = kOptArabicshape,
  [kGlobalOptAutochdir] = kOptAutochdir,
  [kGlobalOptAutoread] = kOptAutoread,
  [kGlobalOptAutowrite] = kOptAutowrite,
  [kGlobalOptAutowriteall] = kOptAutowriteall,
  [kGlobalOptBackground] = kOptBackground,
  [kGlobalOptBackspace] = kOptBackspace,
  [kGlobalOptBackup] = kOptBackup,
  [kGlobalOptBackupcopy] = kOptBackupcopy,
  [kGlobalOptBackupdir] = kOptBackupdir,
  [kGlobalOptBackupext] = kOptBackupext,
  [kGlobalOptBackupskip] = kOptBackupskip,
  [kGlobalOptBelloff] = kOptBelloff,
  [kGlobalOptBreakat] = kOptBreakat,
  [kGlobalOptBrowsedir] = kOptBrowsedir,
  [kGlobalOptCasemap] = kOptCasemap,
  [kGlobalOptCdhome] = kOptCdhome,
  [kGlobalOptCdpath] = kOptCdpath,
  [kGlobalOptCedit] = kOptCedit,
  [kGlobalOptCharconvert] = kOptCharconvert,
  [kGlobalOptChistory] = kOptChistory,
  [kGlobalOptClipboard] = kOptClipboard,
  [kGlobalOptCmdheight] = kOptCmdheight,
  [kGlobalOptCmdwinheight] = kOptCmdwinheight,
  [kGlobalOptColumns] = kOptColumns,
  [kGlobalOptCompatible] = kOptCompatible,
  [kGlobalOptCompletefuzzycollect] = kOptCompletefuzzycollect,
  [kGlobalOptCompleteitemalign] = kOptCompleteitemalign,
  [kGlobalOptCompleteopt] = kOptCompleteopt,
  [kGlobalOptConfirm] = kOptConfirm,
  [kGlobalOptCpoptions] = kOptCpoptions,
  [kGlobalOptDebug] = kOptDebug,
  [kGlobalOptDefine] = kOptDefine,
  [kGlobalOptDelcombine] = kOptDelcombine,
  [kGlobalOptDictionary] = kOptDictionary,
  [kGlobalOptDiffexpr] = kOptDiffexpr,
  [kGlobalOptDiffopt] = kOptDiffopt,
  [kGlobalOptDigraph] = kOptDigraph,
  [kGlobalOptDirectory] = kOptDirectory,
  [kGlobalOptDisplay] = kOptDisplay,
  [kGlobalOptEadirection] = kOptEadirection,
  [kGlobalOptEdcompatible] = kOptEdcompatible,
  [kGlobalOptEmoji] = kOptEmoji,
  [kGlobalOptEncoding] = kOptEncoding,
  [kGlobalOptEqualalways] = kOptEqualalways,
  [kGlobalOptEqualprg] = kOptEqualprg,
  [kGlobalOptErrorbells] = kOptErrorbells,
  [kGlobalOptErrorfile] = kOptErrorfile,
  [kGlobalOptErrorformat] = kOptErrorformat,
  [kGlobalOptEventignore] = kOptEventignore,
  [kGlobalOptExrc] = kOptExrc,
  [kGlobalOptFileencodings] = kOptFileencodings,
  [kGlobalOptFileformats] = kOptFileformats,
  [kGlobalOptFileignorecase] = kOptFileignorecase,
  [kGlobalOptFillchars] = kOptFillchars,
  [kGlobalOptFindfunc] = kOptFindfunc,
  [kGlobalOptFoldclose] = kOptFoldclose,
  [kGlobalOptFoldlevelstart] = kOptFoldlevelstart,
  [kGlobalOptFoldopen] = kOptFoldopen,
  [kGlobalOptFormatprg] = kOptFormatprg,
  [kGlobalOptFsync] = kOptFsync,
  [kGlobalOptGdefault] = kOptGdefault,
  [kGlobalOptGrepformat] = kOptGrepformat,
  [kGlobalOptGrepprg] = kOptGrepprg,
  [kGlobalOptGuicursor] = kOptGuicursor,
  [kGlobalOptGuifont] = kOptGuifont,
  [kGlobalOptGuifontwide] = kOptGuifontwide,
  [kGlobalOptGuioptions] = kOptGuioptions,
  [kGlobalOptGuitablabel] = kOptGuitablabel,
  [kGlobalOptGuitabtooltip] = kOptGuitabtooltip,
  [kGlobalOptHelpfile] = kOptHelpfile,
  [kGlobalOptHelpheight] = kOptHelpheight,
  [kGlobalOptHelplang] = kOptHelplang,
  [kGlobalOptHidden] = kOptHidden,
  [kGlobalOptHighlight] = kOptHighlight,
  [kGlobalOptHistory] = kOptHistory,
  [kGlobalOptHkmap] = kOptHkmap,
  [kGlobalOptHkmapp] = kOptHkmapp,
  [kGlobalOptHlsearch] = kOptHlsearch,
  [kGlobalOptIcon] = kOptIcon,
  [kGlobalOptIconstring] = kOptIconstring,
  [kGlobalOptIgnorecase] = kOptIgnorecase,
  [kGlobalOptImcmdline] = kOptImcmdline,
  [kGlobalOptImdisable] = kOptImdisable,
  [kGlobalOptInccommand] = kOptInccommand,
  [kGlobalOptInclude] = kOptInclude,
  [kGlobalOptIncsearch] = kOptIncsearch,
  [kGlobalOptInsertmode] = kOptInsertmode,
  [kGlobalOptIsfname] = kOptIsfname,
  [kGlobalOptIsident] = kOptIsident,
  [kGlobalOptIsprint] = kOptIsprint,
  [kGlobalOptJoinspaces] = kOptJoinspaces,
  [kGlobalOptJumpoptions] = kOptJumpoptions,
  [kGlobalOptKeymodel] = kOptKeymodel,
  [kGlobalOptKeywordprg] = kOptKeywordprg,
  [kGlobalOptLangmap] = kOptLangmap,
  [kGlobalOptLangmenu] = kOptLangmenu,
  [kGlobalOptLangnoremap] = kOptLangnoremap,
  [kGlobalOptLangremap] = kOptLangremap,
  [kGlobalOptLaststatus] = kOptLaststatus,
  [kGlobalOptLazyredraw] = kOptLazyredraw,
  [kGlobalOptLines] = kOptLines,
  [kGlobalOptLinespace] = kOptLinespace,
  [kGlobalOptLispwords] = kOptLispwords,
  [kGlobalOptListchars] = kOptListchars,
  [kGlobalOptLoadplugins] = kOptLoadplugins,
  [kGlobalOptMagic] = kOptMagic,
  [kGlobalOptMakeef] = kOptMakeef,
  [kGlobalOptMakeencoding] = kOptMakeencoding,
  [kGlobalOptMakeprg] = kOptMakeprg,
  [kGlobalOptMatchtime] = kOptMatchtime,
  [kGlobalOptMaxcombine] = kOptMaxcombine,
  [kGlobalOptMaxfuncdepth] = kOptMaxfuncdepth,
  [kGlobalOptMaxmapdepth] = kOptMaxmapdepth,
  [kGlobalOptMaxmempattern] = kOptMaxmempattern,
  [kGlobalOptMenuitems] = kOptMenuitems,
  [kGlobalOptMessagesopt] = kOptMessagesopt,
  [kGlobalOptMkspellmem] = kOptMkspellmem,
  [kGlobalOptModelineexpr] = kOptModelineexpr,
  [kGlobalOptModelines] = kOptModelines,
  [kGlobalOptMore] = kOptMore,
  [kGlobalOptMouse] = kOptMouse,
  [kGlobalOptMousefocus] = kOptMousefocus,
  [kGlobalOptMousehide] = kOptMousehide,
  [kGlobalOptMousemodel] = kOptMousemodel,
  [kGlobalOptMousemoveevent] = kOptMousemoveevent,
  [kGlobalOptMousescroll] = kOptMousescroll,
  [kGlobalOptMouseshape] = kOptMouseshape,
  [kGlobalOptMousetime] = kOptMousetime,
  [kGlobalOptOpendevice] = kOptOpendevice,
  [kGlobalOptOperatorfunc] = kOptOperatorfunc,
  [kGlobalOptPackpath] = kOptPackpath,
  [kGlobalOptParagraphs] = kOptParagraphs,
  [kGlobalOptPaste] = kOptPaste,
  [kGlobalOptPastetoggle] = kOptPastetoggle,
  [kGlobalOptPatchexpr] = kOptPatchexpr,
  [kGlobalOptPatchmode] = kOptPatchmode,
  [kGlobalOptPath] = kOptPath,
  [kGlobalOptPreviewheight] = kOptPreviewheight,
  [kGlobalOptPrompt] = kOptPrompt,
  [kGlobalOptPumblend] = kOptPumblend,
  [kGlobalOptPumheight] = kOptPumheight,
  [kGlobalOptPummaxwidth] = kOptPummaxwidth,
  [kGlobalOptPumwidth] = kOptPumwidth,
  [kGlobalOptPyxversion] = kOptPyxversion,
  [kGlobalOptQuickfixtextfunc] = kOptQuickfixtextfunc,
  [kGlobalOptRedrawdebug] = kOptRedrawdebug,
  [kGlobalOptRedrawtime] = kOptRedrawtime,
  [kGlobalOptRegexpengine] = kOptRegexpengine,
  [kGlobalOptRemap] = kOptRemap,
  [kGlobalOptReport] = kOptReport,
  [kGlobalOptRevins] = kOptRevins,
  [kGlobalOptRuler] = kOptRuler,
  [kGlobalOptRulerformat] = kOptRulerformat,
  [kGlobalOptRuntimepath] = kOptRuntimepath,
  [kGlobalOptScrolljump] = kOptScrolljump,
  [kGlobalOptScrolloff] = kOptScrolloff,
  [kGlobalOptScrollopt] = kOptScrollopt,
  [kGlobalOptSections] = kOptSections,
  [kGlobalOptSecure] = kOptSecure,
  [kGlobalOptSelection] = kOptSelection,
  [kGlobalOptSelectmode] = kOptSelectmode,
  [kGlobalOptSessionoptions] = kOptSessionoptions,
  [kGlobalOptShada] = kOptShada,
  [kGlobalOptShadafile] = kOptShadafile,
  [kGlobalOptShell] = kOptShell,
  [kGlobalOptShellcmdflag] = kOptShellcmdflag,
  [kGlobalOptShellpipe] = kOptShellpipe,
  [kGlobalOptShellquote] = kOptShellquote,
  [kGlobalOptShellredir] = kOptShellredir,
  [kGlobalOptShellslash] = kOptShellslash,
  [kGlobalOptShelltemp] = kOptShelltemp,
  [kGlobalOptShellxescape] = kOptShellxescape,
  [kGlobalOptShellxquote] = kOptShellxquote,
  [kGlobalOptShiftround] = kOptShiftround,
  [kGlobalOptShortmess] = kOptShortmess,
  [kGlobalOptShowbreak] = kOptShowbreak,
  [kGlobalOptShowcmd] = kOptShowcmd,
  [kGlobalOptShowcmdloc] = kOptShowcmdloc,
  [kGlobalOptShowfulltag] = kOptShowfulltag,
  [kGlobalOptShowmatch] = kOptShowmatch,
  [kGlobalOptShowmode] = kOptShowmode,
  [kGlobalOptShowtabline] = kOptShowtabline,
  [kGlobalOptSidescroll] = kOptSidescroll,
  [kGlobalOptSidescrolloff] = kOptSidescrolloff,
  [kGlobalOptSmartcase] = kOptSmartcase,
  [kGlobalOptSmarttab] = kOptSmarttab,
  [kGlobalOptSpellsuggest] = kOptSpellsuggest,
  [kGlobalOptSplitbelow] = kOptSplitbelow,
  [kGlobalOptSplitkeep] = kOptSplitkeep,
  [kGlobalOptSplitright] = kOptSplitright,
  [kGlobalOptStartofline] = kOptStartofline,
  [kGlobalOptStatusline] = kOptStatusline,
  [kGlobalOptSuffixes] = kOptSuffixes,
  [kGlobalOptSwitchbuf] = kOptSwitchbuf,
  [kGlobalOptTabclose] = kOptTabclose,
  [kGlobalOptTabline] = kOptTabline,
  [kGlobalOptTabpagemax] = kOptTabpagemax,
  [kGlobalOptTagbsearch] = kOptTagbsearch,
  [kGlobalOptTagcase] = kOptTagcase,
  [kGlobalOptTaglength] = kOptTaglength,
  [kGlobalOptTagrelative] = kOptTagrelative,
  [kGlobalOptTags] = kOptTags,
  [kGlobalOptTagstack] = kOptTagstack,
  [kGlobalOptTermbidi] = kOptTermbidi,
  [kGlobalOptTermencoding] = kOptTermencoding,
  [kGlobalOptTermguicolors] = kOptTermguicolors,
  [kGlobalOptTermpastefilter] = kOptTermpastefilter,
  [kGlobalOptTermsync] = kOptTermsync,
  [kGlobalOptTerse] = kOptTerse,
  [kGlobalOptThesaurus] = kOptThesaurus,
  [kGlobalOptThesaurusfunc] = kOptThesaurusfunc,
  [kGlobalOptTildeop] = kOptTildeop,
  [kGlobalOptTimeout] = kOptTimeout,
  [kGlobalOptTimeoutlen] = kOptTimeoutlen,
  [kGlobalOptTitle] = kOptTitle,
  [kGlobalOptTitlelen] = kOptTitlelen,
  [kGlobalOptTitleold] = kOptTitleold,
  [kGlobalOptTitlestring] = kOptTitlestring,
  [kGlobalOptTtimeout] = kOptTtimeout,
  [kGlobalOptTtimeoutlen] = kOptTtimeoutlen,
  [kGlobalOptTtyfast] = kOptTtyfast,
  [kGlobalOptUndodir] = kOptUndodir,
  [kGlobalOptUndolevels] = kOptUndolevels,
  [kGlobalOptUndoreload] = kOptUndoreload,
  [kGlobalOptUpdatecount] = kOptUpdatecount,
  [kGlobalOptUpdatetime] = kOptUpdatetime,
  [kGlobalOptVerbose] = kOptVerbose,
  [kGlobalOptVerbosefile] = kOptVerbosefile,
  [kGlobalOptViewdir] = kOptViewdir,
  [kGlobalOptViewoptions] = kOptViewoptions,
  [kGlobalOptVirtualedit] = kOptVirtualedit,
  [kGlobalOptVisualbell] = kOptVisualbell,
  [kGlobalOptWarn] = kOptWarn,
  [kGlobalOptWhichwrap] = kOptWhichwrap,
  [kGlobalOptWildchar] = kOptWildchar,
  [kGlobalOptWildcharm] = kOptWildcharm,
  [kGlobalOptWildignore] = kOptWildignore,
  [kGlobalOptWildignorecase] = kOptWildignorecase,
  [kGlobalOptWildmenu] = kOptWildmenu,
  [kGlobalOptWildmode] = kOptWildmode,
  [kGlobalOptWildoptions] = kOptWildoptions,
  [kGlobalOptWinaltkeys] = kOptWinaltkeys,
  [kGlobalOptWinbar] = kOptWinbar,
  [kGlobalOptWinborder] = kOptWinborder,
  [kGlobalOptWindow] = kOptWindow,
  [kGlobalOptWinheight] = kOptWinheight,
  [kGlobalOptWinminheight] = kOptWinminheight,
  [kGlobalOptWinminwidth] = kOptWinminwidth,
  [kGlobalOptWinwidth] = kOptWinwidth,
  [kGlobalOptWrapscan] = kOptWrapscan,
  [kGlobalOptWrite] = kOptWrite,
  [kGlobalOptWriteany] = kOptWriteany,
  [kGlobalOptWritebackup] = kOptWritebackup,
  [kGlobalOptWritedelay] = kOptWritedelay,
});

EXTERN const OptIndex buf_opt_idx[] INIT( = {
  [kBufOptAutoindent] = kOptAutoindent,
  [kBufOptAutoread] = kOptAutoread,
  [kBufOptBackupcopy] = kOptBackupcopy,
  [kBufOptBinary] = kOptBinary,
  [kBufOptBomb] = kOptBomb,
  [kBufOptBufhidden] = kOptBufhidden,
  [kBufOptBuflisted] = kOptBuflisted,
  [kBufOptBuftype] = kOptBuftype,
  [kBufOptChannel] = kOptChannel,
  [kBufOptCindent] = kOptCindent,
  [kBufOptCinkeys] = kOptCinkeys,
  [kBufOptCinoptions] = kOptCinoptions,
  [kBufOptCinscopedecls] = kOptCinscopedecls,
  [kBufOptCinwords] = kOptCinwords,
  [kBufOptComments] = kOptComments,
  [kBufOptCommentstring] = kOptCommentstring,
  [kBufOptComplete] = kOptComplete,
  [kBufOptCompletefunc] = kOptCompletefunc,
  [kBufOptCompleteopt] = kOptCompleteopt,
  [kBufOptCompleteslash] = kOptCompleteslash,
  [kBufOptCopyindent] = kOptCopyindent,
  [kBufOptDefine] = kOptDefine,
  [kBufOptDictionary] = kOptDictionary,
  [kBufOptEndoffile] = kOptEndoffile,
  [kBufOptEndofline] = kOptEndofline,
  [kBufOptEqualprg] = kOptEqualprg,
  [kBufOptErrorformat] = kOptErrorformat,
  [kBufOptExpandtab] = kOptExpandtab,
  [kBufOptFileencoding] = kOptFileencoding,
  [kBufOptFileformat] = kOptFileformat,
  [kBufOptFiletype] = kOptFiletype,
  [kBufOptFindfunc] = kOptFindfunc,
  [kBufOptFixendofline] = kOptFixendofline,
  [kBufOptFormatexpr] = kOptFormatexpr,
  [kBufOptFormatlistpat] = kOptFormatlistpat,
  [kBufOptFormatoptions] = kOptFormatoptions,
  [kBufOptFormatprg] = kOptFormatprg,
  [kBufOptGrepprg] = kOptGrepprg,
  [kBufOptIminsert] = kOptIminsert,
  [kBufOptImsearch] = kOptImsearch,
  [kBufOptInclude] = kOptInclude,
  [kBufOptIncludeexpr] = kOptIncludeexpr,
  [kBufOptIndentexpr] = kOptIndentexpr,
  [kBufOptIndentkeys] = kOptIndentkeys,
  [kBufOptInfercase] = kOptInfercase,
  [kBufOptIskeyword] = kOptIskeyword,
  [kBufOptKeymap] = kOptKeymap,
  [kBufOptKeywordprg] = kOptKeywordprg,
  [kBufOptLisp] = kOptLisp,
  [kBufOptLispoptions] = kOptLispoptions,
  [kBufOptLispwords] = kOptLispwords,
  [kBufOptMakeencoding] = kOptMakeencoding,
  [kBufOptMakeprg] = kOptMakeprg,
  [kBufOptMatchpairs] = kOptMatchpairs,
  [kBufOptModeline] = kOptModeline,
  [kBufOptModifiable] = kOptModifiable,
  [kBufOptModified] = kOptModified,
  [kBufOptNrformats] = kOptNrformats,
  [kBufOptOmnifunc] = kOptOmnifunc,
  [kBufOptPath] = kOptPath,
  [kBufOptPreserveindent] = kOptPreserveindent,
  [kBufOptQuoteescape] = kOptQuoteescape,
  [kBufOptReadonly] = kOptReadonly,
  [kBufOptScrollback] = kOptScrollback,
  [kBufOptShiftwidth] = kOptShiftwidth,
  [kBufOptSmartindent] = kOptSmartindent,
  [kBufOptSofttabstop] = kOptSofttabstop,
  [kBufOptSpellcapcheck] = kOptSpellcapcheck,
  [kBufOptSpellfile] = kOptSpellfile,
  [kBufOptSpelllang] = kOptSpelllang,
  [kBufOptSpelloptions] = kOptSpelloptions,
  [kBufOptSuffixesadd] = kOptSuffixesadd,
  [kBufOptSwapfile] = kOptSwapfile,
  [kBufOptSynmaxcol] = kOptSynmaxcol,
  [kBufOptSyntax] = kOptSyntax,
  [kBufOptTabstop] = kOptTabstop,
  [kBufOptTagcase] = kOptTagcase,
  [kBufOptTagfunc] = kOptTagfunc,
  [kBufOptTags] = kOptTags,
  [kBufOptTextwidth] = kOptTextwidth,
  [kBufOptThesaurus] = kOptThesaurus,
  [kBufOptThesaurusfunc] = kOptThesaurusfunc,
  [kBufOptUndofile] = kOptUndofile,
  [kBufOptUndolevels] = kOptUndolevels,
  [kBufOptVarsofttabstop] = kOptVarsofttabstop,
  [kBufOptVartabstop] = kOptVartabstop,
  [kBufOptWrapmargin] = kOptWrapmargin,
});

EXTERN const OptIndex win_opt_idx[] INIT( = {
  [kWinOptArabic] = kOptArabic,
  [kWinOptBreakindent] = kOptBreakindent,
  [kWinOptBreakindentopt] = kOptBreakindentopt,
  [kWinOptColorcolumn] = kOptColorcolumn,
  [kWinOptConcealcursor] = kOptConcealcursor,
  [kWinOptConceallevel] = kOptConceallevel,
  [kWinOptCursorbind] = kOptCursorbind,
  [kWinOptCursorcolumn] = kOptCursorcolumn,
  [kWinOptCursorline] = kOptCursorline,
  [kWinOptCursorlineopt] = kOptCursorlineopt,
  [kWinOptDiff] = kOptDiff,
  [kWinOptEventignorewin] = kOptEventignorewin,
  [kWinOptFillchars] = kOptFillchars,
  [kWinOptFoldcolumn] = kOptFoldcolumn,
  [kWinOptFoldenable] = kOptFoldenable,
  [kWinOptFoldexpr] = kOptFoldexpr,
  [kWinOptFoldignore] = kOptFoldignore,
  [kWinOptFoldlevel] = kOptFoldlevel,
  [kWinOptFoldmarker] = kOptFoldmarker,
  [kWinOptFoldmethod] = kOptFoldmethod,
  [kWinOptFoldminlines] = kOptFoldminlines,
  [kWinOptFoldnestmax] = kOptFoldnestmax,
  [kWinOptFoldtext] = kOptFoldtext,
  [kWinOptLhistory] = kOptLhistory,
  [kWinOptLinebreak] = kOptLinebreak,
  [kWinOptList] = kOptList,
  [kWinOptListchars] = kOptListchars,
  [kWinOptNumber] = kOptNumber,
  [kWinOptNumberwidth] = kOptNumberwidth,
  [kWinOptPreviewwindow] = kOptPreviewwindow,
  [kWinOptRelativenumber] = kOptRelativenumber,
  [kWinOptRightleft] = kOptRightleft,
  [kWinOptRightleftcmd] = kOptRightleftcmd,
  [kWinOptScroll] = kOptScroll,
  [kWinOptScrollbind] = kOptScrollbind,
  [kWinOptScrolloff] = kOptScrolloff,
  [kWinOptShowbreak] = kOptShowbreak,
  [kWinOptSidescrolloff] = kOptSidescrolloff,
  [kWinOptSigncolumn] = kOptSigncolumn,
  [kWinOptSmoothscroll] = kOptSmoothscroll,
  [kWinOptSpell] = kOptSpell,
  [kWinOptStatuscolumn] = kOptStatuscolumn,
  [kWinOptStatusline] = kOptStatusline,
  [kWinOptVirtualedit] = kOptVirtualedit,
  [kWinOptWinbar] = kOptWinbar,
  [kWinOptWinblend] = kOptWinblend,
  [kWinOptWinfixbuf] = kOptWinfixbuf,
  [kWinOptWinfixheight] = kOptWinfixheight,
  [kWinOptWinfixwidth] = kOptWinfixwidth,
  [kWinOptWinhighlight] = kOptWinhighlight,
  [kWinOptWrap] = kOptWrap,
});
